/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-angular-core";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { CategoryFrame } from "./CategoryFrame";
import { Number_$type, typeCast, enumGetBox, EnumUtil, runOn, markType, markDep } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { CategorySeries } from "./CategorySeries";
import { NotImplementedException } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { LineGeometry } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { GeometryGroup } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { Extensions } from "igniteui-angular-core";
import { IndicatorRenderer } from "./IndicatorRenderer";
/**
 * @hidden
 */
export let FinancialIndicator = /*@__PURE__*/ (() => {
    class FinancialIndicator extends FinancialSeries {
        constructor() {
            super();
            this._indicatorColumn = null;
            this.tu = null;
            this.qo = new CategoryFrame(3);
            this.qq = new CategoryFrame(3);
            this.qm = new CategoryFrame(3);
            this.indicatorColumn = new List$1(Number_$type, 0);
            this.tu = new AxisRange(-100, 100);
        }
        get_dt() {
            return true;
        }
        by() {
            return new FinancialIndicatorView(this);
        }
        l4(a) {
            super.l4(a);
            this.tv = a;
        }
        t8(a) {
            if (this.q6 != null && !this.q6.c0()) {
                this.mn(true);
            }
        }
        t0(a, b, c) {
            if (isNaN_(b.x) || isNaN_(b.y)) {
                return false;
            }
            let d = this.q6;
            let e = 0;
            if (d != null) {
                e = d.e3(d.l6);
            }
            if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
                return true;
            }
            return false;
        }
        bq() {
            if (this.br == 0) {
                return 1;
            }
            else {
                return super.bq();
            }
        }
        p3(a) {
            if (this.qk == null || this.q6 == null) {
                return Rect.empty;
            }
            let b = this.pn(a);
            let c = this.b1.bv;
            let d = this.b1.bu;
            let e = this.getEffectiveViewport1(this.b1);
            let f = new ScalerParams(0, c, d, this.q6.cg, e);
            f.b = this.gg();
            let g = this.aj(this.qk, this.qm.f, this.sh(this.b1), this.sj(this.b1), a, true);
            if (g == null) {
                return Rect.empty;
            }
            let h = g[0];
            let i = g[1];
            let j = Math.abs(b.x - h[0]);
            let k = Math.abs(b.x - i[0]);
            let l = this.q6.ei(this.q6.l6, f);
            let m = 1;
            if (j < k) {
                let n = h[0] - 0.5 * m;
                let o = h[1];
                let p = l;
                return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
            }
            else {
                let q = i[0] - 0.5 * m;
                let r = i[1];
                let s = l;
                return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
            }
        }
        ez(a, b) {
            let c = this.ps(this.px(a), true, false);
            if (this.tx == 1) {
                if (this.t0(a, c, b)) {
                    return true;
                }
            }
            if (this.tx == 1 || this.tx == 0) {
                if (this.ey(a, b)) {
                    return true;
                }
            }
            if (this.tx == 2) {
                if (this.e2(a, b)) {
                    return true;
                }
            }
            return false;
        }
        k5(a, b, c, d) {
            super.k5(a, b, c, d);
            if (this.qk != null && typeCast(ISortingAxis_$type, this.qk) !== null) {
                this.qk.i$i();
            }
            if (this.tv.b7) {
                this.tv.b5.g$e(a, b, c, d);
            }
            if (d != null && this.rw.containsKey(d)) {
                let e = this.rw.tryGetValue(d, d);
                d = e.p1;
            }
            if (this.qk != null && typeCast(ISortingAxis_$type, this.qk) !== null) {
                a = 4;
                b = 0;
                c = this.cl.count;
            }
            switch (a) {
                case 3:
                    if (this.tz(b, c, d)) {
                        this.ua(b, c, d);
                        this.t8(true);
                    }
                    break;
                case 2:
                    if (this.tz(b, this.cl.count - b, d)) {
                        this.ua(b, this.cl.count - b, d);
                        this.t8(true);
                    }
                    break;
                case 1:
                    if (this.tz(b, this.cl.count - b, d)) {
                        let f = new Array(c);
                        for (let g = 0; g < c; g++) {
                            f[g] = 0;
                        }
                        this.indicatorColumn.s(b, f);
                        this.ua(b, this.cl.count - b, d);
                        this.t8(true);
                    }
                    break;
                case 0:
                    if (this.tz(b, this.cl.count - b, d)) {
                        this.indicatorColumn.v(b, c);
                        this.ua(b, this.cl.count - b, d);
                        this.t8(true);
                    }
                    break;
                case 4:
                    if (this.tz(b, this.cl.count - b, d)) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.cl.count);
                        let h = new Array(c);
                        for (let i = 0; i < c; i++) {
                            h[i] = 0;
                        }
                        this.indicatorColumn.s(0, h);
                        this.ua(b, this.cl.count - b, d);
                        this.t8(true);
                    }
                    break;
            }
        }
        get_tw() {
            return 0;
        }
        get tw() {
            return this.get_tw();
        }
        get ul() {
            return this.c(FinancialIndicator.ub);
        }
        set ul(a) {
            this.h(FinancialIndicator.ub, a);
        }
        t5() {
            return -1;
        }
        get indicatorColumn() {
            return this._indicatorColumn;
        }
        set indicatorColumn(a) {
            this._indicatorColumn = a;
        }
        l9(a, b, c, d) {
            switch (b) {
                case "XAxis":
                    this.tv.cd();
                    break;
                case "TrendLineType":
                    let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                    if (e != 0) {
                        this.tv.b5 = CategoryTrendLineManagerFactory.a(this.tv.b5, this.qk, this.nf, this, this.co);
                    }
                    break;
            }
            super.l9(a, b, c, d);
            if (this.tv.b7 && this.tv.b5.g$b(a, b, c, d)) {
                this.mn(false);
                let f = typeCast(FinancialIndicatorView.$, this.b0);
                if (f != null && f.b7) {
                    f.b5.g$b(a, b, c, d);
                }
                this.lu();
            }
            switch (b) {
                case "FastItemsSource":
                    if (this.cl != null) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.cl.count);
                        let g = new Array(this.cl.count);
                        for (let h = 0; h < this.cl.count; h++) {
                            g[h] = 0;
                        }
                        this.indicatorColumn.s(0, g);
                        this.ua(0, this.cl.count, null);
                        if (this.q6 != null && !this.q6.c0()) {
                            this.q1.bx.e(this.fx);
                            this.mn(false);
                        }
                    }
                    break;
                case "TrendLineBrush":
                    this.m1();
                    break;
                case FinancialIndicator.$$p[0]:
                    this.k2(true, this.b1);
                    this.m2();
                    this.mn(false);
                    this.lu();
                    break;
                case "OpenColumn":
                case "HighColumn":
                case "LowColumn":
                case "CloseColumn":
                case "VolumeColumn":
                    if (this.cl != null) {
                        if (this.indicatorColumn.count != this.cl.count) {
                            this.indicatorColumn = new List$1(Number_$type, 2, this.cl.count);
                            let i = new Array(this.cl.count);
                            for (let j = 0; j < this.cl.count; j++) {
                                i[j] = 0;
                            }
                            this.indicatorColumn.s(0, i);
                        }
                        if (this.tz(0, this.cl.count - 1, b)) {
                            this.t9();
                        }
                    }
                    break;
                case "XAxis":
                    if (this.qk != null && (typeCast(ISortingAxis_$type, this.qk) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                        this.t9();
                    }
                    break;
                case "YAxis":
                case FinancialIndicator.$$p[1]:
                    this.t9();
                    this.lu();
                    break;
                case "TrendLineType":
                    this.lu();
                    break;
            }
        }
        gn(a, b, c) {
            if (this.indicatorColumn == null) {
                return super.gn(a, b, c);
            }
            let d = this.getEffectiveViewport1(this.b1);
            let e = this.sb(this.b1.bv, this.b1.bu, d);
            let f = new ScalerParams(0, this.b1.bv, this.b1.bu, this.qk.cg, d);
            f.c = this.ce.tp;
            return this.gp(this.indicatorColumn, a, this.qk, f, e, runOn(this, this.sa), b, c);
        }
        ho(a, b) {
            if (this.indicatorColumn == null) {
                return super.ho(a, b);
            }
            return this.hp(a, b, this.qk, runOn(this, this.sa), this.indicatorColumn);
        }
        hm(a, b) {
            if (this.indicatorColumn == null) {
                return super.hm(a, b);
            }
            return this.hn(a, b, this.qk, runOn(this, this.sa), this.indicatorColumn);
        }
        get_fc() {
            return true;
        }
        tz(a, b, c) {
            if (c == null) {
                return true;
            }
            if (this.t1(a, b).contains(c)) {
                return true;
            }
            return false;
        }
        ua(a, b, c) {
            this.ty(a, b);
        }
        aq(a) {
            if (this.cl == null) {
                return null;
            }
            if (a != null && a == this.q6) {
                return this.tu;
            }
            return null;
        }
        eq(a) {
            let b = this.cl != null ? this.cl.indexOf(a) : -1;
            let c = this.b1.bv;
            c = c.copy();
            let d = this.b1.bu;
            let e = new Rect(0, 0, 0, 1, 1);
            let f = this.p1(this.b1);
            if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
                if (this.qk != null) {
                    let g = new ScalerParams(0, e, e, this.qk.cg, f);
                    let h = this.qk.ei(b, g);
                    if (h < c.left + 0.1 * c.width) {
                        h = h + 0.4 * c.width;
                    }
                    if (h > c.right - 0.1 * c.width) {
                        h = h - 0.4 * c.width;
                    }
                    c.x = h - 0.5 * c.width;
                }
                if (this.q6 != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                    let i = new ScalerParams(0, e, e, this.q6.cg, f);
                    i.b = this.gg();
                    let j = this.q6.ei(this.indicatorColumn._inner[b], i);
                    if (j < c.top + 0.1 * c.height) {
                        j = j + 0.4 * c.height;
                    }
                    if (j > c.bottom - 0.1 * c.height) {
                        j = j - 0.4 * c.height;
                    }
                    c.y = j - 0.5 * c.height;
                }
                this.b9.au(this.ce, c, true);
            }
            return b >= 0;
        }
        fd(a, b, c) {
            let d = super.fd(a, b, c);
            if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
                d = false;
            }
            return d;
        }
        tb(a, b) {
            super.tb(a, b);
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.qk;
            let g = this.q6;
            let h = new ScalerParams(0, c, d, f.cg, e);
            let i = new ScalerParams(0, c, d, g.cg, e);
            i.b = this.gg();
            a.f.clear();
            a.m.clear();
            a.p.clear();
            let j = 0;
            let k = typeCast(ISortingAxis_$type, this.qk);
            if (k != null && k.i$b.count != this.cl.count) {
                return;
            }
            j = this.sb(c, d, e);
            let l = this.t5();
            if (l == -1) {
                l = this.trendLinePeriod;
            }
            let m = typeCast(FinancialIndicatorView.$, b);
            if (m.b7) {
                m.b5.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, l, (n) => this.qk.ei(n, h), (n) => this.q6.ei(n, i), ((() => {
                    let $ret = new TrendResolutionParams();
                    $ret.c = b.bx.b;
                    $ret.d = b.bx.c;
                    $ret.e = b.bx.d;
                    $ret.a = j;
                    $ret.b = this.fx;
                    $ret.f = d;
                    $ret.g = c;
                    return $ret;
                })()));
            }
            let n = this.qk.el(2, h) - this.qk.el(1, h);
            for (let o = b.bx.c; o <= b.bx.d; ++o) {
                let p;
                if (k == null) {
                    p = b.bx.getBucket(o);
                }
                else {
                    let q = k.i$b._inner[o];
                    let r = k.i$d(q);
                    let s = this.indicatorColumn._inner[o];
                    let t = s;
                    let u = r;
                    while (o < b.bx.d) {
                        q = k.i$b._inner[o + 1];
                        u = k.i$d(q);
                        if (u - r > n) {
                            break;
                        }
                        o++;
                        let v = this.indicatorColumn._inner[o];
                        s = Math.min(s, v);
                        t = Math.max(t, v);
                    }
                    let w = NaN;
                    if (!isNaN_(r)) {
                        w = this.qk.ei(r, h);
                    }
                    p = [w, s, t];
                }
                if (!isNaN_(p[0])) {
                    if (this.qk != null && typeCast(ISortingAxis_$type, this.qk) !== null) {
                        p[0] = p[0] + j;
                    }
                    else {
                        p[0] = f.ei(p[0], h) + j;
                    }
                    p[1] = g.ei(p[1], i);
                    if (b.bx.b > 1 || k != null) {
                        p[2] = g.ei(p[2], i);
                    }
                    else {
                        p[2] = p[1];
                    }
                    a.f.add(p);
                }
            }
            return;
        }
        k2(a, b) {
            super.k2(a, b);
            let c = b;
            c.b8(a);
            if (c.b7) {
                c.b5.g$d();
            }
        }
        qu() {
            switch (this.tx) {
                case 1: return 1;
                case 2: return 1;
                case 0: return 12;
            }
            return 1;
        }
        td(a, b) {
            super.td(a, b);
            let c = typeCast(FinancialIndicatorView.$, b);
            let d = (e) => a.f._inner[e][0];
            let e = (f) => a.f._inner[f][1];
            if (c.b7) {
                c.b5.g$d();
                c.b5.g$g(a.p);
            }
            let f = b.bu;
            let g = this.getEffectiveViewport1(b);
            let h = 0;
            let i = this.o5;
            let j = this.tq;
            if (b.b0(a)) {
                c.b8(false);
                if (a.f.count > 0) {
                    switch (this.tx) {
                        case 0:
                            let k = CategorySeries.rr(a.f, a.f.count - 1, f, b.bv, false);
                            c.cc(a.f.count, d, e, true, k);
                            break;
                        case 1:
                            if (this.q6 != null) {
                                h = this.sf(b);
                            }
                            else {
                                h = 0.5 * (f.top + f.bottom);
                            }
                            let l = CategorySeries.rr(a.f, a.f.count - 1, f, b.bv, false);
                            c.ca(a.f.count, d, e, true, h, l);
                            break;
                        case 2:
                            h = this.sf(b);
                            c.cb(a.f.count, d, e, true, h);
                            break;
                        default: throw new NotImplementedException(0);
                    }
                }
                b.b2(a);
            }
            let m = a.f;
            let n = this.cl.count;
            this.qt.a2(this, this.rs(), runOn(this, this.qc), this.sh(b), this.sj(b));
            let o = false;
            let p = this.qt.b;
            if (p != null) {
                o = true;
            }
            this.qt.ak = i;
            this.qt.ag = i;
            if (o) {
                let q = new ScalerParams(0, b.bv, b.bu, this.qk.cg, g);
                this.qt.f = false;
                this.ta(m, -1, n, this.qk, q, b.q);
            }
            this.qt.ad(c.cu, true, false, true, false);
            this.qt.ad(c.cw, true, false, true, false);
            this.qt.ad(c.cv, false, true, false, false);
            c.cv._opacity = 0.8 * this.qt.j * this.fu;
            this.qt.ad(c.ct, true, false, false, false);
            this.qt.ak = j;
            this.qt.ag = j;
            if (o) {
                let r = new ScalerParams(0, b.bv, b.bu, this.qk.cg, g);
                this.qt.f = true;
                this.ta(m, -1, n, this.qk, r, b.q);
            }
            this.qt.ad(c.cq, true, false, true, false);
            this.qt.ad(c.cs, true, false, true, false);
            this.qt.ad(c.cr, false, true, false, false);
            c.cr._opacity = 0.8 * this.qt.j * this.fu;
            this.qt.ad(c.cp, true, false, false, false);
            c.ce();
        }
        m1() {
            super.m1();
            if (this.index < 0) {
                return;
            }
            if (this.tv.b7) {
                this.tv.cf();
            }
        }
        t9() {
            if (this.tv.b7) {
                this.tv.b5.g$i();
            }
            this.ty(0, this.indicatorColumn.count);
            if (this.q6 != null && !this.q6.c0()) {
                this.mn(false);
            }
        }
        lc(a) {
            super.lc(a);
            this.a9.exportTrendlineData(this, a, this.tv.b5.g$j);
        }
        bb(a) {
            if (this.tx == 1 || this.tx == 2) {
                return 3;
            }
            else if (this.tx == 0) {
                return 2;
            }
            return a;
        }
    }
    FinancialIndicator.$t = markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialIndicator.ub = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    FinancialIndicator.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:tx:uc', [IndicatorDisplayType_$type, enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:t3:ud', [1, 0], 'TrendLineType::uj', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::ui', [1, 1.5], 'TrendLinePeriod::uh', [1, 7], 'TrendLineBrush::ue', [Brush.$, null], 'TrendLineZIndex:t4:uk', [1, 1001], 'TrendLineDashArray:um:uf', [DoubleCollection.$], 'TrendLineDashCap:un:ug', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialIndicator;
})();
/**
 * @hidden
 */
export let FinancialIndicatorBucketCalculator = /*@__PURE__*/ (() => {
    class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = a * this.b;
            let c = Math.min(b + this.b - 1, this.f.b3.indicatorColumn.count - 1);
            let d = NaN;
            let e = NaN;
            for (let f = b; f <= c; ++f) {
                let g = this.f.b3.indicatorColumn._inner[f];
                if (!isNaN_(d)) {
                    if (!isNaN_(g)) {
                        d = Math.min(d, g);
                        e = Math.max(e, g);
                    }
                }
                else {
                    d = g;
                    e = g;
                }
            }
            if (!isNaN_(d)) {
                return [0.5 * (b + c), d, e];
            }
            return [NaN, NaN, NaN];
        }
    }
    FinancialIndicatorBucketCalculator.$t = markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
    return FinancialIndicatorBucketCalculator;
})();
/**
 * @hidden
 */
export let FinancialIndicatorView = /*@__PURE__*/ (() => {
    class FinancialIndicatorView extends FinancialSeriesView {
        constructor(a) {
            super(a);
            this.b3 = null;
            this.b6 = null;
            this.cu = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cq = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cv = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cr = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cw = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.cs = ((() => {
                let $ret = new Path();
                $ret.an = new PathGeometry();
                return $ret;
            })());
            this.ct = ((() => {
                let $ret = new Path();
                $ret.an = new GeometryGroup();
                return $ret;
            })());
            this.cp = ((() => {
                let $ret = new Path();
                $ret.an = new GeometryGroup();
                return $ret;
            })());
            this.b4 = null;
            this.cm = new Path();
            this.co = new Path();
            this.cn = new Path();
            this.cl = new Path();
            this.ci = new Path();
            this.ck = new Path();
            this.cj = new Path();
            this.ch = new Path();
            this.b3 = a;
            this.b6 = ((() => {
                let $ret = new Pool$1(LineGeometry.$);
                $ret.create = runOn(this, this.cg);
                $ret.destroy = runOn(this, this.b9);
                return $ret;
            })());
        }
        by() {
            return new FinancialIndicatorBucketCalculator(this);
        }
        as() {
            super.as();
            if (!this.q) {
                this.b3.tq = Defaults.ah;
                this.b3.tx = this.b3.tw;
            }
        }
        cg() {
            return new LineGeometry();
        }
        b9(a) {
        }
        get b5() {
            if (this.b4 == null) {
                this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.as(), this.e.nf, this.e, this.e.co);
            }
            return this.b4;
        }
        set b5(a) {
            this.b4 = a;
        }
        get b7() {
            return this.b4 != null;
        }
        b8(a) {
            Extensions.e(this.cu.an);
            Extensions.e(this.cv.an);
            Extensions.e(this.cw.an);
            Extensions.e(this.cq.an);
            Extensions.e(this.cr.an);
            Extensions.e(this.cs.an);
            Extensions.d(this.ct.an);
            Extensions.d(this.cp.an);
            if (a) {
                this.b6.count = 0;
            }
            this.aq();
        }
        ce() {
        }
        cc(a, b, c, d, e) {
            IndicatorRenderer.g(a, b, c, d, this.bv, this.bu, this.cu, this.cq, this.bx.b, this.e.fx, e);
            this.aq();
        }
        ca(a, b, c, d, e, f) {
            IndicatorRenderer.e(a, b, c, d, this.bv, this.bu, this.cu, this.cv, this.cq, this.cr, e, this.bx.b, this.e.fx, f);
            this.aq();
        }
        cb(a, b, c, d, e) {
            IndicatorRenderer.f(a, b, c, d, this.bu, e, this.b6, this.ct, this.cp);
            this.aq();
        }
        cf() {
            this.b3.ul = null;
            if (this.b3.trendLineBrush != null) {
                this.b3.ul = this.b3.trendLineBrush;
            }
            else {
                this.b3.ul = this.b3.o5;
            }
        }
        bc() {
            super.bc();
            let a = this.bo();
            this.cm.an = this.cu.an;
            this.co.an = this.cw.an;
            this.cn.an = this.cv.an;
            this.cl.an = this.ct.an;
            this.ci.an = this.cq.an;
            this.ck.an = this.cs.an;
            this.cj.an = this.cr.an;
            this.ch.an = this.cp.an;
            this.cm._stroke = a;
            this.co._stroke = a;
            this.cm.ad = this.e.fy + 3;
            this.co.ad = this.e.fy + 3;
            this.cn._fill = a;
            this.cn._opacity = 1;
            this.cl._stroke = a;
            this.cl.ad = this.e.fy + 3;
            this.ci._stroke = a;
            this.ck._stroke = a;
            this.ci.ad = this.e.fy + 3;
            this.ck.ad = this.e.fy + 3;
            this.cj._fill = a;
            this.cj._opacity = 1;
            this.ch._stroke = a;
            this.ch.ad = this.e.fy + 3;
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d) {
                if (b) {
                    if (this.b3.tx == 2) {
                        a.t(this.cl);
                        a.t(this.ch);
                    }
                    else {
                        a.t(this.cn);
                        a.t(this.cm);
                        a.t(this.co);
                        a.t(this.cj);
                        a.t(this.ci);
                        a.t(this.ck);
                    }
                }
                else {
                    if (this.b3.tx == 2) {
                        a.t(this.ct);
                        a.t(this.cp);
                    }
                    else {
                        a.t(this.cv);
                        a.t(this.cu);
                        a.t(this.cw);
                        a.t(this.cr);
                        a.t(this.cq);
                        a.t(this.cs);
                    }
                }
            }
        }
        a5(a, b) {
            if (a.d) {
                if (this.b3.trendLineType != 0 && !b) {
                    let c = this.b5.g$j;
                    c.ad = this.b3.trendLineThickness;
                    c._stroke = this.b3.ul;
                    c.aj = this.b3.un;
                    c.ai = this.b3.um;
                    a.v(c);
                }
            }
            super.a5(a, b);
        }
        al(a) {
            super.al(a);
            this.e.a9.exportPathData(a, this.ct, "positiveColumnsShape", ["Positive", "Main"]);
            this.e.a9.exportPathData(a, this.cp, "negativeColumnsShape", ["Negative"]);
            this.e.a9.exportPathData(a, this.cu, "positive0", ["Positive", "Main"]);
            this.e.a9.exportPathData(a, this.cw, "positive1", ["Positive"]);
            this.e.a9.exportPathData(a, this.cv, "positive01", ["PositiveFill"]);
            this.e.a9.exportPathData(a, this.cq, "negative0", ["Negative", "Main"]);
            this.e.a9.exportPathData(a, this.cs, "negative1", ["Negative"]);
            this.e.a9.exportPathData(a, this.cr, "negative01", ["NegativeFill"]);
        }
        cd() {
            if (this.b7) {
                this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.as(), this.e.nf, this.e, this.e.co);
            }
        }
    }
    FinancialIndicatorView.$t = markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
    return FinancialIndicatorView;
})();
