import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxSplineFragmentBaseComponent } from "./igx-spline-fragment-base-component";
import { IgxSplineSeriesBaseComponent } from "./igx-spline-series-base-component";
import { IgxHorizontalAnchoredCategorySeriesComponent } from "./igx-horizontal-anchored-category-series-component";
import { IgxAnchoredCategorySeriesComponent } from "./igx-anchored-category-series-component";
import { IgxCategorySeriesComponent } from "./igx-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { SplineFragment } from "./SplineFragment";
import * as i0 from "@angular/core";
/**
 * Represents one part of a StackedSplineSeries.
*/
export let IgxSplineFragmentComponent = /*@__PURE__*/ (() => {
    class IgxSplineFragmentComponent extends IgxSplineFragmentBaseComponent {
        constructor() {
            super();
        }
        createImplementation() {
            return new SplineFragment();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        /**
         * Gets whether the current series shows a spline shape.
        */
        get isSpline() {
            return this.i.ej;
        }
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get isAreaOrLine() {
            return this.i.dg;
        }
    }
    IgxSplineFragmentComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxSplineFragmentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxSplineFragmentComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxSplineFragmentComponent, selector: "igx-spline-fragment", providers: [{ provide: IgxSplineFragmentBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }], usesInheritance: true, ngImport: i0, template: ``, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
    return IgxSplineFragmentComponent;
})();
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxSplineFragmentComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'igx-spline-fragment',
                    template: ``,
                    providers: [{ provide: IgxSplineFragmentBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return []; } });
