import { IgxSeriesComponent } from "./igx-series-component";
import { CalloutLabelUpdatingEventArgs as CalloutLabelUpdatingEventArgs_internal } from "./CalloutLabelUpdatingEventArgs";
/**
 * Represents event arguments for updating label of callout layer
*/
var IgxCalloutLabelUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgxCalloutLabelUpdatingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxCalloutLabelUpdatingEventArgs.prototype.createImplementation = function () {
        return new CalloutLabelUpdatingEventArgs_internal();
    };
    Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgxCalloutLabelUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxCalloutLabelUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "xValue", {
        /**
         * Gets data X-value assositated with callout layer
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "yValue", {
        /**
         * Gets data Y-value assositated with callout layer
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "item", {
        /**
         * Gets data item assositated with callout layer
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "series", {
        /**
         * Gets series assositated with callout item, if available
        */
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgxSeriesComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "seriesName", {
        /**
         * Gets series name assositated with callout item, if available
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "label", {
        /**
         * Gets or sets label displayed by callout layer
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgxCalloutLabelUpdatingEventArgs;
}());
export { IgxCalloutLabelUpdatingEventArgs };
