import { __extends } from "tslib";
import { ListSortDirection } from "igniteui-angular-core";
import { IgxChartSortDescription } from "./igx-chart-sort-description";
import { ChartGroupDescription } from "./ChartGroupDescription";
/**
 * Represents an element in the current grouping applied to a data source or provider. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
var IgxChartGroupDescription = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxChartGroupDescription, _super);
    function IgxChartGroupDescription(field, sortDirection) {
        if (field === void 0) {
            field = null;
        }
        if (sortDirection === void 0) {
            sortDirection = ListSortDirection.Ascending;
        }
        return _super.call(this, field, sortDirection) || this;
    }
    IgxChartGroupDescription.prototype.createImplementation = function () {
        return new ChartGroupDescription(0);
    };
    Object.defineProperty(IgxChartGroupDescription.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    return IgxChartGroupDescription;
}(IgxChartSortDescription));
export { IgxChartGroupDescription };
