import { FunnelDataContext as FunnelDataContext_internal } from "./FunnelDataContext";
/**
 * Represents contextual data for the funnel chart.
*/
var IgxFunnelDataContext = /** @class */ /*@__PURE__*/ (function () {
    function IgxFunnelDataContext() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxFunnelDataContext.prototype.createImplementation = function () {
        return new FunnelDataContext_internal();
    };
    Object.defineProperty(IgxFunnelDataContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgxFunnelDataContext.prototype.onImplementationCreated = function () {
    };
    IgxFunnelDataContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxFunnelDataContext.prototype, "item", {
        /**
         * The data item that is in context.
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxFunnelDataContext.prototype, "index", {
        /**
         * The index of the data item that is in context.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgxFunnelDataContext.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgxFunnelDataContext;
}());
export { IgxFunnelDataContext };
