import { EventEmitter, Output, Component, Input } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core";
import { MarkerAutomaticBehavior_$type } from "./MarkerAutomaticBehavior";
import { SeriesHighlightingMode_$type } from "./SeriesHighlightingMode";
import { SeriesViewerScrollbarMode_$type } from "./SeriesViewerScrollbarMode";
import { SeriesViewerHorizontalScrollbarPosition_$type } from "./SeriesViewerHorizontalScrollbarPosition";
import { SeriesViewerVerticalScrollbarPosition_$type } from "./SeriesViewerVerticalScrollbarPosition";
import { SeriesHighlightingBehavior_$type } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode_$type } from "./LegendHighlightingMode";
import { LegendItemBadgeShape_$type } from "igniteui-angular-core";
import { LegendItemBadgeMode_$type } from "igniteui-angular-core";
import { ChartHitTestMode_$type } from "./ChartHitTestMode";
import { WindowResponse_$type } from "./WindowResponse";
import { Visibility_$type } from "igniteui-angular-core";
import { ZoomCoercionMode_$type } from "./ZoomCoercionMode";
import { InteractionState_$type } from "igniteui-angular-core";
import { ModifierKeys_$type } from "igniteui-angular-core";
import { HorizontalAlignment_$type } from "igniteui-angular-core";
import { IgxPlotAreaMouseButtonEventArgs } from "./igx-plot-area-mouse-button-event-args";
import { IgxPlotAreaMouseEventArgs } from "./igx-plot-area-mouse-event-args";
import { IgxChartCursorEventArgs } from "./igx-chart-cursor-event-args";
import { IgxDataChartMouseButtonEventArgs } from "./igx-data-chart-mouse-button-event-args";
import { IgxChartMouseEventArgs } from "./igx-chart-mouse-event-args";
import { IgxSeriesViewerManipulationEventArgs } from "./igx-series-viewer-manipulation-event-args";
import { IgxRectChangedEventArgs } from "igniteui-angular-core";
import { IgxRefreshCompletedEventArgs } from "./igx-refresh-completed-event-args";
import { TypeRegistrar } from "igniteui-angular-core";
import { NamePatcher, toBrushCollection, fromBrushCollection, ensureEnum, fromPoint, toPoint, ensureBool, brushToString, stringToBrush, fromRect, toRect, toSpinal, initializePropertiesFromCss } from "igniteui-angular-core";
import * as i0 from "@angular/core";
/**
 * Represents a control for viewing series objects.
*/
var IgxSeriesViewerComponent = /** @class */ /*@__PURE__*/ (function () {
    function IgxSeriesViewerComponent() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._plotAreaMouseLeftButtonDown = null;
        this._plotAreaMouseLeftButtonUp = null;
        this._plotAreaClicked = null;
        this._plotAreaMouseEnter = null;
        this._plotAreaMouseLeave = null;
        this._plotAreaMouseOver = null;
        this._seriesCursorMouseMove = null;
        this._seriesMouseLeftButtonDown = null;
        this._seriesMouseLeftButtonUp = null;
        this._seriesMouseMove = null;
        this._seriesMouseEnter = null;
        this._seriesMouseLeave = null;
        this._viewerManipulationStarting = null;
        this._viewerManipulationEnding = null;
        this._windowRectChanged = null;
        this._sizeChanged = null;
        this._actualWindowRectChanged = null;
        this._gridAreaRectChanged = null;
        this._refreshCompleted = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxSeriesViewerComponent.prototype.createImplementation = function () {
        return null;
    };
    IgxSeriesViewerComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: false,
        configurable: true
    });
    IgxSeriesViewerComponent._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgxSeriesViewerComponent.prototype.onImplementationCreated = function () {
    };
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "brushes", {
        /**
         * Gets or sets the palette of brushes used for fill of plotted series.
         * These brushes are automatically assigned to series based on the index of series.
        */
        get: function () {
            return fromBrushCollection(this.i.ag);
        },
        set: function (v) {
            this.i.ag = toBrushCollection(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "outlines", {
        /**
         * Gets or sets the palette of brushes used for outlines of plotted series.
         * These outlines are automatically assigned to series based on the index of series.
        */
        get: function () {
            return fromBrushCollection(this.i.aj);
        },
        set: function (v) {
            this.i.aj = toBrushCollection(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "markerBrushes", {
        /**
         * Gets or sets the palette of brushes used for fill of marker series.
         * These brushes are automatically assigned to markers based on the index of series.
        */
        get: function () {
            return fromBrushCollection(this.i.ah);
        },
        set: function (v) {
            this.i.ah = toBrushCollection(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "markerOutlines", {
        /**
         * Gets or sets the palette of brushes used for outlines of plotted markers.
         * These outlines are automatically assigned to markers based on the index of series.
        */
        get: function () {
            return fromBrushCollection(this.i.ai);
        },
        set: function (v) {
            this.i.ai = toBrushCollection(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "markerAutomaticBehavior", {
        /**
         * Gets or sets the marker mode used for assigning a marker type to series when the marker type is automatic.
        */
        get: function () {
            return this.i.be;
        },
        set: function (v) {
            this.i.be = ensureEnum(MarkerAutomaticBehavior_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "crosshairPoint", {
        /**
         * Gets or sets the cross hair point (in world coordinates)
         * Either or both of the crosshair point's X and Y may be set to double.NaN, in which
         * case the relevant crosshair line is hidden.
        *
        * The `CrosshairPoint` property is used to gets/sets the cross hair point (in world coordinates).
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     crosshairVisibility="visible"
        *     crosshairPoint={x:.8,y:.2}>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.crosshairPoint = {x:.8,y:.2};
        * ```
        */
        get: function () {
            return fromPoint(this.i.s1);
        },
        set: function (v) {
            this.i.s1 = toPoint(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "animateSeriesWhenAxisRangeChanges", {
        /**
         * Gets or sets whether the series animations should be allowed when a range change has been detected on an axis.
        *
        * `AnimateSeriesWhenAxisRangeChanges` is a Boolean property to override the default behavior in which series do not animate if an axis range changes.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     animateSeriesWhenAxisRangeChanges=true>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         transitionInMode="accordionFromBottom"
        *         isTransitionInEnabled=true
        *         transitionInSpeedType="indexScaled"
        *         transitionDuration=1000>
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.animateSeriesWhenAxisRangeChanges = true;
        * ```
        */
        get: function () {
            return this.i.ds;
        },
        set: function (v) {
            this.i.ds = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "isWindowSyncedToVisibleRange", {
        /**
         * Gets or sets whether to sync the vertical aspect of the window with the contained series content. This is only supported for a subset of the available series.
        */
        get: function () {
            return this.i.ep;
        },
        set: function (v) {
            this.i.ep = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "shouldSimulateHoverMoveCrosshairPoint", {
        /**
         * Gets or sets whether calling SimulateHover should shift the crosshair point.
        */
        get: function () {
            return this.i.fa;
        },
        set: function (v) {
            this.i.fa = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "highlightingMode", {
        /**
         * Gets or sets the highlighting mode to use for the series in the component, when supported. This takes precedence over the series level IsHightlightingEnabled.
        */
        get: function () {
            return this.i.bv;
        },
        set: function (v) {
            this.i.bv = ensureEnum(SeriesHighlightingMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarMode", {
        /**
         * Gets or sets the horizontal scrollbar mode to use for the series viewer.
        */
        get: function () {
            return this.i.b5;
        },
        set: function (v) {
            this.i.b5 = ensureEnum(SeriesViewerScrollbarMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarMode", {
        /**
         * Gets or sets the vertical scrollbar mode to use for the series viewer.
        */
        get: function () {
            return this.i.b6;
        },
        set: function (v) {
            this.i.b6 = ensureEnum(SeriesViewerScrollbarMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarPosition", {
        /**
         * Gets or sets the position to use for the horizontal scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.b2;
        },
        set: function (v) {
            this.i.b2 = ensureEnum(SeriesViewerHorizontalScrollbarPosition_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarPosition", {
        /**
         * Gets or sets the position to use for the vertical scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.b7;
        },
        set: function (v) {
            this.i.b7 = ensureEnum(SeriesViewerVerticalScrollbarPosition_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarFill", {
        /**
         * Gets or sets the fill to use for the horizontal scrollbar in the component, when enabled.
        */
        get: function () {
            return brushToString(this.i.sp);
        },
        set: function (v) {
            this.i.sp = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarOutline", {
        /**
         * Gets or sets the outline to use for the horizontal scrollbar in the component, when enabled.
        */
        get: function () {
            return brushToString(this.i.sq);
        },
        set: function (v) {
            this.i.sq = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarStrokeThickness", {
        /**
         * Gets or sets the stroke thickness to use for the horizontal scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.gt;
        },
        set: function (v) {
            this.i.gt = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarMaxOpacity", {
        /**
         * Gets or sets the max opacity to use for the horizontal scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.gs;
        },
        set: function (v) {
            this.i.gs = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarCornerRadius", {
        /**
         * Gets or sets the corner radius to use for the horizontal scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.gp;
        },
        set: function (v) {
            this.i.gp = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarHeight", {
        /**
         * Gets or sets the height to use for the horizontal scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.gq;
        },
        set: function (v) {
            this.i.gq = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarInset", {
        /**
         * Gets or sets the inset distance to use for the horizontal scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.gr;
        },
        set: function (v) {
            this.i.gr = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarTrackStartInset", {
        /**
         * Gets or sets the track start inset to use for the horizontal scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.gv;
        },
        set: function (v) {
            this.i.gv = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarTrackEndInset", {
        /**
         * Gets or sets the track end inset to use for the horizontal scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.gu;
        },
        set: function (v) {
            this.i.gu = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalViewScrollbarShouldAddAutoTrackInsets", {
        /**
         * Gets or sets whether to use automatic track insets for the horizontal scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.d5;
        },
        set: function (v) {
            this.i.d5 = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarFill", {
        /**
         * Gets or sets the fill to use for the vertical scrollbar in the component, when enabled.
        */
        get: function () {
            return brushToString(this.i.sy);
        },
        set: function (v) {
            this.i.sy = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarOutline", {
        /**
         * Gets or sets the outline to use for the vertical scrollbar in the component, when enabled.
        */
        get: function () {
            return brushToString(this.i.sz);
        },
        set: function (v) {
            this.i.sz = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarStrokeThickness", {
        /**
         * Gets or sets the stroke thickness to use for the vertical scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.hf;
        },
        set: function (v) {
            this.i.hf = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarMaxOpacity", {
        /**
         * Gets or sets the max opacity to use for the vertical scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.he;
        },
        set: function (v) {
            this.i.he = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarCornerRadius", {
        /**
         * Gets or sets the corner radius to use for the vertical scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.hc;
        },
        set: function (v) {
            this.i.hc = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarWidth", {
        /**
         * Gets or sets the width to use for the vertical scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.hi;
        },
        set: function (v) {
            this.i.hi = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarInset", {
        /**
         * Gets or sets the inset distance to use for the vertical scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.hd;
        },
        set: function (v) {
            this.i.hd = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarTrackStartInset", {
        /**
         * Gets or sets the track start inset to use for the vertical scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.hh;
        },
        set: function (v) {
            this.i.hh = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarTrackEndInset", {
        /**
         * Gets or sets the track end inset to use for the vertical scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.hg;
        },
        set: function (v) {
            this.i.hg = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalViewScrollbarShouldAddAutoTrackInsets", {
        /**
         * Gets or sets whether to use automatic track insets for the vertical scrollbar in the component, when enabled.
        */
        get: function () {
            return this.i.fj;
        },
        set: function (v) {
            this.i.fj = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "highlightingBehavior", {
        /**
         * Gets or sets the highlighting Behavior to use for the series in the component, when supported. This takes precedence over the series level IsHightlightingEnabled.
        */
        get: function () {
            return this.i.bt;
        },
        set: function (v) {
            this.i.bt = ensureEnum(SeriesHighlightingBehavior_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "legendHighlightingMode", {
        /**
         * Gets or sets the highlighting mode to use for the legend linked to the component, when supported.
        */
        get: function () {
            return this.i.bb;
        },
        set: function (v) {
            this.i.bb = ensureEnum(LegendHighlightingMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "legendItemBadgeShape", {
        /**
         * Gets or sets type of legend badges representing all series displayed in a legend linked to this component
         * This property will be ignored when the LegendItemTemplate or LegendItemBadgeTemplate property is set on a series
        */
        get: function () {
            return this.i.bd;
        },
        set: function (v) {
            this.i.bd = ensureEnum(LegendItemBadgeShape_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "legendItemBadgeMode", {
        /**
         * Gets or sets the mode of legend badges representing all series in this chart.
         * This property will be ignored when the LegendItemTemplate or LegendItemBadgeTemplate property is set on a series
        */
        get: function () {
            return this.i.bc;
        },
        set: function (v) {
            this.i.bc = ensureEnum(LegendItemBadgeMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "viewportRect", {
        /**
         * Gets the viewport rectangle associated with the SeriesViewer, the physical dimensions of the plot area.
        *
        * ```ts
        * let viewPortRect: IgxRect = this.chart.viewportRect;
        * ```
        */
        get: function () {
            return fromRect(this.i.tp);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "effectiveViewport", {
        /**
         * Gets the EffectiveViewport rectangle, representing the effective viewport area after margins have been subtracted.
        *
        *  ``ts
        * let viewport: IgxRect = this.chart.effectiveViewport;
        *
        * ```
        *
        * ```
        */
        get: function () {
            return fromRect(this.i.te);
        },
        set: function (v) {
            this.i.te = toRect(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "contentViewport", {
        /**
         * Represents the subset area within the viewport into which content should be mapped.
         * This is the projection of the current EffectiveViewport into the viewport at current zoom level.
        *
        * ```ts
        * let contentViewport: IgxRect = this.chart.contentViewport;
        * ```
        */
        get: function () {
            return fromRect(this.i.td);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowRect", {
        /**
         * A rectangle representing the portion of the SeriesViewer currently in view.
         * A rectangle at X=0, Y=0 with a Height and Width of 1 implies the entire plotting area is in view.  A Height and Width of .5 would imply that the view is halfway zoomed in.
        *
        * You can set the `WindowRect` to zoom in on an area of interest in the chart.
        *
        * ```ts
        * this.chart.windowRect = {left:0, top:1, width: .5, height: .5};
        * ```
        */
        get: function () {
            return fromRect(this.i.tq);
        },
        set: function (v) {
            this.i.tq = toRect(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "useTiledZooming", {
        /**
         * Gets or sets whether the series viewer should use cached tiles during zooms rather than the default live content.
        */
        get: function () {
            return this.i.fi;
        },
        set: function (v) {
            this.i.fi = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "preferHigherResolutionTiles", {
        /**
         * Gets or sets whether the series viewer should prefer selecting higher resolution tiles over lower resolution tiles when performing tile zooming. Setting this to true will lower performance but increase quality.
        */
        get: function () {
            return this.i.e5;
        },
        set: function (v) {
            this.i.e5 = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "zoomTileCacheSize", {
        /**
         * Gets or sets the maximum number of zoom tiles that the series viewer should cache while in tiled zooming mode.
        */
        get: function () {
            return this.i.hy;
        },
        set: function (v) {
            this.i.hy = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "highlightingTransitionDuration", {
        /**
         * Gets or sets the duration the highlighting/de-highlighting effects.
        *
        * The `HighlightingTransitionDuration` property is used to set the time for highlighting transition in milliseconds .
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        * 	HighlightingTransitionDuration=500 >
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value" >
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * chart.HighlightingTransitionDuration=500;
        * ```
        */
        get: function () {
            return this.i.hw;
        },
        set: function (v) {
            this.i.hw = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "scrollbarsAnimationDuration", {
        /**
         * Gets or sets the duration of the scrollbar effects.
        */
        get: function () {
            return this.i.hx;
        },
        set: function (v) {
            this.i.hx = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "isPagePanningAllowed", {
        /**
         * Gets or sets the whether the series viewer can allow the page to pan if a control pan is not possible in the requested direction.
        */
        get: function () {
            return this.i.ek;
        },
        set: function (v) {
            this.i.ek = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "contentHitTestMode", {
        /**
         * Determines the method of hit testing used when mousing over elements in the chart.
        *
        * ```ts
        * this.chart.contentHitTestMode = ChartHitTestMode.Computational;
        * ```
        */
        get: function () {
            return this.i.av;
        },
        set: function (v) {
            this.i.av = ensureEnum(ChartHitTestMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualContentHitTestMode", {
        /**
         * Resolved method of hit testing used when the pointer is over elements in the chart.
        *
        * ```ts
        * let actualContentHitTestMode: ChartHitTestMode  =this.chart.actualContentHitTestMode;
        * ```
        */
        get: function () {
            return this.i.au;
        },
        set: function (v) {
            this.i.au = ensureEnum(ChartHitTestMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "isSurfaceInteractionDisabled", {
        /**
         * Gets or sets whether all surface interactions with the plot area should be disabled.
        *
        * The `IsSurfaceInteractionDisabled` property is used to enable/disable interactions with the plot surface.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     isSurfaceInteractionDisabled=true>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * chart.isSurfaceInteractionDisabled=true;
        * ```
        */
        get: function () {
            return this.i.el;
        },
        set: function (v) {
            this.i.el = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "isMap", {
        /**
         * Indicates if this SeriesViewer is a map.
        */
        get: function () {
            return this.i.ej;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowResponse", {
        /**
         * The response to user panning and zooming: whether to update the view immediately while the user action is happening, or to defer the update to after the user action is complete.  The user action will be an action such as a mouse drag which causes panning and/or zooming to occur.
        *
        * The `WindowResponse` property is used to set the response to user panning and zooming: whether to update the view immediately while the user action is happening, or to defer the update to after the user action is complete.
        * The user action will be an action such as a mouse drag which causes panning and/or zooming to occur.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     isHorizontalZoomEnabled=true
        *     windowResponse="deferred">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.windowResponse="deferred";
        * ```
        */
        get: function () {
            return this.i.cb;
        },
        set: function (v) {
            this.i.cb = ensureEnum(WindowResponse_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowRectMinWidth", {
        /**
         * Sets or gets the minimum width that the window rect is allowed to reach before being clamped.
         * Decrease this value if you want to allow for further zooming into the viewer.
         * If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
         * This property accepts values between 0.0 (max zooming) and 1.0 (no zooming)
        *
        * The `WindowRectMinWidth` property is used to set or get the minimum width that the window rect is allowed to reach before being clamped.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     isHorizontalZoomEnabled=true
        *     windowRectMinWidth=.2>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.WindowRectMinWidth=".2";
        * ```
        */
        get: function () {
            return this.i.hm;
        },
        set: function (v) {
            this.i.hm = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowRectMinHeight", {
        /**
         * Sets or gets the minimum height that the window rect is allowed to reach before being clamped.
         * Decrease this value if you want to allow for further zooming into the viewer.
         * If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
         * This property accepts values between 0.0 (max zooming) and 1.0 (no zooming)
        */
        get: function () {
            return this.i.hl;
        },
        set: function (v) {
            this.i.hl = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowRectMinWidth", {
        /**
         * Gets the actual minimum width that the window rect is allowed to reach before being clamped.
        */
        get: function () {
            return this.i.gh;
        },
        set: function (v) {
            this.i.gh = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowRectMinHeight", {
        /**
         * Gets the actual minimum height that the window rect is allowed to reach before being clamped.
        */
        get: function () {
            return this.i.gg;
        },
        set: function (v) {
            this.i.gg = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowSizeMinWidth", {
        /**
         * Sets or gets minimum pixel width that the window is allowed to reach before being clamped.
         * Decrease this value if you want to allow for further zooming into the viewer.
         * If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
         * This property is overridden by the WindowRectMinWidth property
        */
        get: function () {
            return this.i.ho;
        },
        set: function (v) {
            this.i.ho = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowSizeMinHeight", {
        /**
         * Sets or gets minimum pixel height that the window is allowed to reach before being clamped.
         * Decrease this value if you want to allow for further zooming into the viewer.
         * If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
         * This property is overridden by the WindowRectMinHeight property
        */
        get: function () {
            return this.i.hn;
        },
        set: function (v) {
            this.i.hn = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "crosshairVisibility", {
        /**
         * Gets or sets the current SeriesViewer's crosshair visibility override.
        *
        * The `CrosshairVisibility` property is used to gets or sets the current Chart's crosshair visibility override. Note: setting this property does not affect the mobile browser version of the chart.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     crosshairVisibility="visible">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.crosshairVisibility = Visibility.Visible;
        * ```
        */
        get: function () {
            return this.i.tu;
        },
        set: function (v) {
            this.i.tu = ensureEnum(Visibility_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "horizontalCrosshairBrush", {
        /**
         * Gets or sets the current SeriesViewer's crosshair horizontal brush override.
        */
        get: function () {
            return brushToString(this.i.so);
        },
        set: function (v) {
            this.i.so = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "verticalCrosshairBrush", {
        /**
         * Gets or sets the current SeriesViewer's crosshair vertical brush override.
        */
        get: function () {
            return brushToString(this.i.sx);
        },
        set: function (v) {
            this.i.sx = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "zoomCoercionMode", {
        /**
         * Gets or sets zoom is contrained to within the axes. Setting this to false is a preview feature at the present time.
        */
        get: function () {
            return this.i.cf;
        },
        set: function (v) {
            this.i.cf = ensureEnum(ZoomCoercionMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaBackground", {
        /**
         * Gets or sets the brush used as the background for the current SeriesViewer object's plot area.
        *
        * `PlotAreaBackground` property set the background brush to the current Chart object's plot area.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     plotAreaBackground="#F0F8FF">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.plotAreaBackground="#F0F8FF";
        * ```
        */
        get: function () {
            return brushToString(this.i.sr);
        },
        set: function (v) {
            this.i.sr = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "defaultInteraction", {
        /**
         * Gets or sets the DefaultInteraction property.
         * The default interaction state defines the SeriesViewer's response to mouse events.
        *
        * The default interaction state defines the chart's response to mouse events.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     isHorizontalZoomEnabled=true
        *     defaultInteraction="dragPan">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.defaultInteraction = InteractionState.DragPan;
        * ```
        */
        get: function () {
            return this.i.ci;
        },
        set: function (v) {
            this.i.ci = ensureEnum(InteractionState_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "rightButtonDefaultInteraction", {
        /**
         * Gets or sets the RightButtonDefaultInteraction property.
         * The default interaction state defines the SeriesViewer's response to right button mouse events.
        */
        get: function () {
            return this.i.ck;
        },
        set: function (v) {
            this.i.ck = ensureEnum(InteractionState_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "dragModifier", {
        /**
         * Gets or sets the current SeriesViewer's DragModifier property.
        *
        * `DragModifier` is useful to enable zooming when zooming is not the default interaction.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     isHorizontalZoomEnabled=true
        *     defaultInteraction="dragPan"
        *     dragModifier="alt">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.dragModifier = ModifierKeys.Alt;
        * ```
        */
        get: function () {
            return this.i.sa;
        },
        set: function (v) {
            this.i.sa = ensureEnum(ModifierKeys_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "panModifier", {
        /**
         * Gets or sets the current SeriesViewer's PanModifier property.
        *
        * `PanModifier` is useful to enable panning when panning is not the default interaction.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     isHorizontalZoomEnabled=true
        *     defaultInteraction="dragZoom"
        *     panModifier="alt">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.panModifier = ModifierKeys.Alt;
        * ```
        */
        get: function () {
            return this.i.sb;
        },
        set: function (v) {
            this.i.sb = ensureEnum(ModifierKeys_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "previewRect", {
        /**
         * Gets or sets the preview rectangle.
         * The preview rectangle may be set to Rect.Empty, in which case the visible preview
         * strokePath is hidden.
        *
        * `PreviewRect` can be used to highlight an area of importance.
        *
        * ```ts
        * this.chart.previewRect = {left:0,top:0,height:.5,width:.5};
        * ```
        */
        get: function () {
            return fromRect(this.i.tk);
        },
        set: function (v) {
            this.i.tk = toRect(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowPositionHorizontal", {
        /**
         * A number between 0 and 1 determining the position of the horizontal scroll.
         * This property is effectively a shortcut to the X position of the WindowRect property.
        *
        * ```ts
        * this.chart.windowPositionHorizontal = .2;
        * ```
        */
        get: function () {
            return this.i.hj;
        },
        set: function (v) {
            this.i.hj = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowPositionVertical", {
        /**
         * A number between 0 and 1 determining the position of the vertical scroll.
         * This property is effectively a shortcut to the Y position of the WindowRect property.
        *
        * ```ts
        * this.chart.windowPositionVertical = .2;
        * ```
        */
        get: function () {
            return this.i.hk;
        },
        set: function (v) {
            this.i.hk = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "chartTitle", {
        /**
         * Text to display above the plot area.
        *
        * The `Title` property is used to set the title to display for the component.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.title="Items Sold";
        * ```
        */
        get: function () {
            return this.i.kh;
        },
        set: function (v) {
            this.i.kh = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleHorizontalAlignment", {
        /**
         * Gets or sets the TitleHorizontalAlignment property.
        *
        * The `subtitleHorizontalAlignment` property is used to set horizontal alignment for the subtitle.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     subtitle="date of sale: 1/1/2018"
        *     titleHorizontalAlignment="left"
        *     subtitleHorizontalAlignment="left">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.titleHorizontalAlignment="left";
        * ```
        */
        get: function () {
            return this.i.r9;
        },
        set: function (v) {
            this.i.r9 = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleHorizontalAlignment", {
        /**
         * Gets or sets the SubtitleHorizontalAlignment property.
        *
        * The `subtitleBottomMargin` property is used to set the horizontal alignment for the subtitle.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     subtitle="Date of Sale: 1/1/2018"
        *     titleHorizontalAlignment="left"
        *     subtitleHorizontalAlignment="left">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.subtitleHorizontalAlignment="left";
        * ```
        */
        get: function () {
            return this.i.r8;
        },
        set: function (v) {
            this.i.r8 = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleTextStyle", {
        /**
         * Font settings for the title.
        */
        get: function () {
            return this.i.ko;
        },
        set: function (v) {
            this.i.ko = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleTextStyle", {
        /**
         * Font settings for the subtitle.
        */
        get: function () {
            return this.i.kc;
        },
        set: function (v) {
            this.i.kc = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleTextColor", {
        /**
         * Gets or sets the Color used for the Title Text.
        *
        * The `titleTextColor` property is used to set the title brush.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     subtitle="date of sale: 1/1/2018"
        *     titleTextColor="blue">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.titleTextColor="blue" ;
        * ```
        */
        get: function () {
            return brushToString(this.i.sw);
        },
        set: function (v) {
            this.i.sw = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleTextColor", {
        /**
         * Gets or sets the Color used for the Subtitle Text.
        *
        * The `subtitleTextColor` property is used to set the color for the subtitle.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     subtitle="Date of Sale: 1/1/2018"
        *     subtitleTextColor="blue">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.subtitleTextColor="blue";
        * ```
        */
        get: function () {
            return brushToString(this.i.sv);
        },
        set: function (v) {
            this.i.sv = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleTopMargin", {
        /**
         * Margin applied above the title.
        *
        * The `titleTopMargin` property is used to set the top margin for the title.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     titleLeftMarging=10
        *     titleTopMargin=10
        *     titleRightMargin=10
        *     titleBottomMargin=20>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.titleTopMargin=10;
        * ```
        */
        get: function () {
            return this.i.ha;
        },
        set: function (v) {
            this.i.ha = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleLeftMargin", {
        /**
         * Margin applied to the left of the title.
        *
        * The `titleLeftMarging` property is used to set the left margin for the title.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     titleLeftMarging=10
        *     titleTopMargin=10
        *     titleRightMargin=10
        *     titleBottomMargin=20>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.titleLeftMarging=10;
        * ```
        */
        get: function () {
            return this.i.g8;
        },
        set: function (v) {
            this.i.g8 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleRightMargin", {
        /**
         * Margin applied to the right of the title.
        *
        * The `titleRightMargin` property is used to set the right margin for the title.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     titleLeftMarging=10
        *     titleTopMargin=10
        *     titleRightMargin=10
        *     titleBottomMargin=20>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.titleRightMargin=10;
        * ```
        */
        get: function () {
            return this.i.g9;
        },
        set: function (v) {
            this.i.g9 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleBottomMargin", {
        /**
         * Margin applied below the title.
        *
        * The `titleBottomMargin` property is used to set the bottom margin for the title.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     titleLeftMarging=10
        *     titleTopMargin=10
        *     titleRightMargin=10
        *     titleBottomMargin=20>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.titleBottomMargin=20;
        * ```
        */
        get: function () {
            return this.i.g7;
        },
        set: function (v) {
            this.i.g7 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleTopMargin", {
        /**
         * Margin applied above the subtitle.
        *
        * The `subtitleTopMargin` property is used to set the top margin for the subtitle.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     subtitle="date of sale: 1/1/2018"
        *     subtitleLeftMarging=10
        *     subtitleTopMargin=10
        *     subtitleRightMargin=10
        *     subtitleBottomMargin=20>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.subtitleTopMargin =10;
        * ```
        */
        get: function () {
            return this.i.g6;
        },
        set: function (v) {
            this.i.g6 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleLeftMargin", {
        /**
         * Margin applied to the left of the subtitle.
        *
        * The `subtitleLeftMarging` property is used to set the left margin for the subtitle.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     subtitle="date of sale: 1/1/2018"
        *     subtitleLeftMarging=10
        *     subtitleTopMargin=10
        *     subtitleRightMargin=10
        *     subtitleBottomMargin=20>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.subtitleLeftMarging=10;
        * ```
        */
        get: function () {
            return this.i.g4;
        },
        set: function (v) {
            this.i.g4 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleRightMargin", {
        /**
         * Margin applied to the right of the subtitle.
        *
        * The `subTitleRightMargin` property is used to set the right margin for the subtitle.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     subtitle="date of sale: 1/1/2018"
        *     subtitleLeftMarging=10
        *     subtitleTopMargin=10
        *     subTitleRightMargin=10
        *     subtitleBottomMargin=20>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.subtitleLeftMarging=10;
        * ```
        */
        get: function () {
            return this.i.g5;
        },
        set: function (v) {
            this.i.g5 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleBottomMargin", {
        /**
         * Margin applied below the subtitle.
        *
        * The `subtitleBottomMargin` property is used to set the bottom margin for the subtitle.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     subtitle="date of sale: 1/1/2018"
        *     subtitleLeftMarging=10
        *     subtitleTopMargin=10
        *     subtitleRightMargin=10
        *     subtitleBottomMargin=20>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.subtitleBottomMargin = 20;
        * ```
        */
        get: function () {
            return this.i.g3;
        },
        set: function (v) {
            this.i.g3 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitle", {
        /**
         * Gets or sets the Subtitle property.
         * The Title property defines the Subtitle of the chart
        *
        * The `Subtitle` property is used to display subtitle for the component.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     title="Items Sold"
        *     subtitle="Date of Sale: 1/1/2018">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.subtitle="Date of Sale: 1/1/2018";
        * ```
        */
        get: function () {
            return this.i.j5;
        },
        set: function (v) {
            this.i.j5 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "topMargin", {
        /**
         * Sets or gets the top margin to use around the chart content.
        *
        * The `topMargin` property is used to set the top margin.
        *
        * ```html
        *  <igx-data-chart
        *     [dataSource]="data"
        *     leftMargin=20
        *     rightMargin=20
        *     topMargin=30
        *     bottomMargin=20>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.topMargin=30;
        * ```
        */
        get: function () {
            return this.i.hb;
        },
        set: function (v) {
            this.i.hb = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "leftMargin", {
        /**
         * Sets or gets the left margin to use around the chart content.
        *
        * The `LeftMargin` property is used to set the left margin.
        *
        * ```html
        *  <igx-data-chart
        *     [dataSource]="data"
        *     leftMargin=20
        *     rightMargin=20
        *     topMargin=30
        *     bottomMargin=20>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        *  this.chart.leftMargin = 20;
        * ```
        */
        get: function () {
            return this.i.gx;
        },
        set: function (v) {
            this.i.gx = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "rightMargin", {
        /**
         * Sets or gets the right margin to use around the chart content.
        *
        * The `RightMargin` property is used to set the left margin around the chart content in the canvas.
        *
        * ```html
        *  <igx-data-chart
        *     [dataSource]="data"
        *     leftMargin=20
        *     rightMargin=20
        *     topMargin=30
        *     bottomMargin=20>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.rightMargin=20;
        * ```
        */
        get: function () {
            return this.i.g2;
        },
        set: function (v) {
            this.i.g2 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "bottomMargin", {
        /**
         * Sets or gets the bottom margin to use around the chart content.
        *
        * The `bottomMargin` property is used to gets/set the bottom margin around the chart content in the canvas.
        *
        * ```ts
        * this.chart.bottomMargin = 50;
        * ```
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     bottomMargin=50>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
        get: function () {
            return this.i.gk;
        },
        set: function (v) {
            this.i.gk = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "autoMarginWidth", {
        /**
         * Sets or gets the automatic width to add when automatically adding margins to the chart.
        *
        * The `autoMarginWidth` propertry is used find the automatic width to add when automatically adding margins to the chart.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     autoMarginWidth=50>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.chart.autoMarginWidth = 50;
        * ```
        */
        get: function () {
            return this.i.gj;
        },
        set: function (v) {
            this.i.gj = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "autoMarginHeight", {
        /**
         * Sets or gets the automatic height to add when automatically adding margins to the chart.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     autoMarginHeight=50>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        *  this.chart.autoMarginHeight = 50;
        * ```
        */
        get: function () {
            return this.i.gi;
        },
        set: function (v) {
            this.i.gi = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "isAntiAliasingEnabledDuringInteraction", {
        /**
         * Gets or sets the IsAntiAliasingEnabledDuringInteraction property.
        */
        get: function () {
            return this.i.ea;
        },
        set: function (v) {
            this.i.ea = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.gy;
        },
        set: function (v) {
            this.i.gy = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "interactionPixelScalingRatio", {
        /**
         * Method of pixel scaling to use during end user interaction with the chart.
        */
        get: function () {
            return this.i.gw;
        },
        set: function (v) {
            this.i.gw = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualPixelScalingRatio", {
        /**
         * Gets the resolved pixel scaling ratio.
        *
        * A higher scaling ratio will produce crisper visuals at the expense of memory. Lower values will cause the control to appear blurry
        *
        * ```ts
        * let actualPixelScalingRatio: number = this.chart.actualPixelScalingRatio;
        * ```
        */
        get: function () {
            return this.i.gd;
        },
        set: function (v) {
            this.i.gd = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualInteractionPixelScalingRatio", {
        /**
         * Resolved method of pixel scaling to use during end user interaction with the chart.
        *
        * ```ts
        * let actualInteractionPixelScalingRatio: number = this.chart.actualInteractionPixelScalingRatio;
        * ```
        */
        get: function () {
            return this.i.gc;
        },
        set: function (v) {
            this.i.gc = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "shouldPanOnMaximumZoom", {
        /**
         * Gets or sets a whether the chart should pan its content when zooing in passed max zoom level.
        */
        get: function () {
            return this.i.e9;
        },
        set: function (v) {
            this.i.e9 = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowRect", {
        /**
         * Gets the actual value of the window rectangle, which represents the current zoom level.
        *
        * ```ts
        * let actualWindowRect: IgxRect = this.chart.actualWindowRect;
        * ``
        * ```
        */
        get: function () {
            return fromRect(this.i.ta);
        },
        set: function (v) {
            this.i.ta = toRect(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowPositionHorizontal", {
        /**
         * A number between 0 and 1 determining the position of the horizontal scroll.
         * This property is effectively a shortcut to the Left of the ActualWindowRect property.
        *
        * ```ts
        * let actualWindowPositionHorizontal: number = this.chart.actualWindowPositionHorizontal;
        * ```
        */
        get: function () {
            return this.i.ge;
        },
        set: function (v) {
            this.i.ge = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowPositionVertical", {
        /**
         * A number between 0 and 1 determining the position of the vertical scroll.
         * This property is effectively a shortcut to the Top of the ActualWindowRect property.
        *
        * ```ts
        * let actualWindowPositionVertical: number = this.chart.actualWindowPositionVertical;
        * ``
        * ```
        */
        get: function () {
            return this.i.gf;
        },
        set: function (v) {
            this.i.gf = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgxSeriesViewerComponent.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.series != null && this.series.findByName && this.series.findByName(name)) {
            return this.series.findByName(name);
        }
        if (this.legend && this.legend.name && this.legend.name == name) {
            return this.legend;
        }
        return null;
    };
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgxSeriesViewerComponent.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgxSeriesViewerComponent.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("SeriesViewerComponent");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgxSeriesViewerComponent.prototype.getDesiredToolbarActions = function () {
        var iv = this.i.getDesiredToolbarActions();
        return (iv);
    };
    IgxSeriesViewerComponent.prototype.onToolCommandExecuting = function (command) {
        this.i.onToolCommandExecuting(command);
    };
    IgxSeriesViewerComponent.prototype.addCommandAvailabilityListener = function (listener) {
        this.i.addCommandAvailabilityListener(listener);
    };
    IgxSeriesViewerComponent.prototype.removeCommandAvailabilityListener = function (listener) {
        this.i.removeCommandAvailabilityListener(listener);
    };
    IgxSeriesViewerComponent.prototype.addCommandStateChangedListener = function (listener) {
        this.i.addCommandStateChangedListener(listener);
    };
    IgxSeriesViewerComponent.prototype.removeCommandStateChangedListener = function (listener) {
        this.i.removeCommandStateChangedListener(listener);
    };
    /**
     * Hides the active main tooltip, if displayed.
    
    *
    * ```ts
    * this.chart.hideToolTip();
    * ```
    */
    IgxSeriesViewerComponent.prototype.hideToolTip = function () {
        this.i.l1();
    };
    IgxSeriesViewerComponent.prototype.simulateHover = function (point) {
        this.i.o0(toPoint(point));
    };
    /**
     * Manually starts a tiled zoom if one isn't already running.
    
    */
    IgxSeriesViewerComponent.prototype.startTiledZoomingIfNecessary = function () {
        this.i.o2();
    };
    /**
     * Manually ends a tiled zoom if one is running.
    
    */
    IgxSeriesViewerComponent.prototype.endTiledZoomingIfRunning = function () {
        this.i.lv();
    };
    /**
     * Clears the tile zoom tile cache so that new tiles will be generated. Only applies if the viewer is using a tile based zoom.
    
    */
    IgxSeriesViewerComponent.prototype.clearTileZoomCache = function () {
        this.i.lp();
    };
    /**
     * Performs zoom in action on the chart by specified percentage of current window rect
    
    */
    IgxSeriesViewerComponent.prototype.zoomIn = function (percentage) {
        this.i.pk(percentage);
    };
    /**
     * Performs zoom out action on the chart by specified percentage of current window rect
    
    */
    IgxSeriesViewerComponent.prototype.zoomOut = function (percentage) {
        this.i.pl(percentage);
    };
    /**
     * Resets the zoom level to default.
    
    */
    IgxSeriesViewerComponent.prototype.resetZoom = function () {
        this.i.ou();
    };
    IgxSeriesViewerComponent.prototype.cancelManipulation = function () {
        this.i.ln();
    };
    /**
     * Gets actual window scale for horizontal dimension of the control
    
    *
    * ```ts
    * let actualWindowScaleHorizontal: number = chart.getActualWindowScaleHorizontal();
    * ```
    */
    IgxSeriesViewerComponent.prototype.getActualWindowScaleHorizontal = function () {
        var iv = this.i.gn();
        return (iv);
    };
    /**
     * Gets actual window scale for vertical dimension of the control
    
    *
    * ```ts
    * let actualWindowScaleVertical: number = chart.getActualWindowScaleVertical();
    * ```
    */
    IgxSeriesViewerComponent.prototype.getActualWindowScaleVertical = function () {
        var iv = this.i.go();
        return (iv);
    };
    /**
     * Notification from the containing object that the container has been resized.
    
    */
    IgxSeriesViewerComponent.prototype.notifyContainerResized = function () {
        this.i.notifyContainerResized();
    };
    /**
     * Attaches the given series to the chart.
    
    * @param s  * The series to attach to the chart.
    */
    IgxSeriesViewerComponent.prototype.attachSeries = function (s) {
        this.i.ll((s == null ? null : s.i));
    };
    IgxSeriesViewerComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.mj(source_, index, oldItem, newItem);
    };
    /**
     * Used to manually notify the SeriesViewer that the data source has reset or cleared its items.  Invoking this method is only necessary if that datasource is not observable.
    
    * @param source_  * The data source which was cleared or reset.
    *
    * ```ts
    * this.chart.notifyClearItems(this.data);
    * ```
    */
    IgxSeriesViewerComponent.prototype.notifyClearItems = function (source_) {
        this.i.ma(source_);
    };
    IgxSeriesViewerComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.mh(source_, index, newItem);
    };
    IgxSeriesViewerComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.mi(source_, index, oldItem);
    };
    /**
     * Release any resources held by the control.
    
    */
    IgxSeriesViewerComponent.prototype.destroy = function () {
        this.i.destroy();
    };
    IgxSeriesViewerComponent.prototype.getCurrentActualWindowRect = function () {
        var iv = this.i.tg();
        return fromRect(iv);
    };
    IgxSeriesViewerComponent.prototype.renderToImage = function (width, height) {
        var iv = this.i.h0(width, height);
        return (iv);
    };
    /**
     * Use to force the SeriesViewer to finish any deferred work before printing or evaluating its visual.
     * This should only be called if the visual of the SeriesViewer needs to be synchronously saved or evaluated.
     * Calling this method too often will hinder the performance of the SeriesViewer.
    
    *
    * ```ts
    * this.chart.flush();
    * ```
    */
    IgxSeriesViewerComponent.prototype.flush = function () {
        this.i.flush();
    };
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaMouseLeftButtonDown", {
        /**
         * Occurs when the left mouse button is pressed while the mouse pointer is over the plot area.
        */
        get: function () {
            var _this = this;
            if (this._plotAreaMouseLeftButtonDown == null) {
                this._plotAreaMouseLeftButtonDown = new EventEmitter();
                this.i.plotAreaMouseLeftButtonDown = delegateCombine(this.i.plotAreaMouseLeftButtonDown, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxPlotAreaMouseButtonEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforePlotAreaMouseLeftButtonDown) {
                            _this.beforePlotAreaMouseLeftButtonDown(_this, outerArgs);
                        }
                        _this._plotAreaMouseLeftButtonDown.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._plotAreaMouseLeftButtonDown;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaMouseLeftButtonUp", {
        /**
         * Occurs when the left mouse button is pressed while the mouse pointer is over the plot area.
        */
        get: function () {
            var _this = this;
            if (this._plotAreaMouseLeftButtonUp == null) {
                this._plotAreaMouseLeftButtonUp = new EventEmitter();
                this.i.plotAreaMouseLeftButtonUp = delegateCombine(this.i.plotAreaMouseLeftButtonUp, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxPlotAreaMouseButtonEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforePlotAreaMouseLeftButtonUp) {
                            _this.beforePlotAreaMouseLeftButtonUp(_this, outerArgs);
                        }
                        _this._plotAreaMouseLeftButtonUp.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._plotAreaMouseLeftButtonUp;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaClicked", {
        /**
         * Occurs when the left mouse button is clicked while the mouse pointer is over the plot area.
        */
        get: function () {
            var _this = this;
            if (this._plotAreaClicked == null) {
                this._plotAreaClicked = new EventEmitter();
                this.i.plotAreaClicked = delegateCombine(this.i.plotAreaClicked, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxPlotAreaMouseButtonEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforePlotAreaClicked) {
                            _this.beforePlotAreaClicked(_this, outerArgs);
                        }
                        _this._plotAreaClicked.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._plotAreaClicked;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaMouseEnter", {
        /**
         * Occurs when the pointer enters the plot area.
        */
        get: function () {
            var _this = this;
            if (this._plotAreaMouseEnter == null) {
                this._plotAreaMouseEnter = new EventEmitter();
                this.i.plotAreaMouseEnter = delegateCombine(this.i.plotAreaMouseEnter, function (o, e) {
                    var outerArgs = new IgxPlotAreaMouseEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforePlotAreaMouseEnter) {
                        _this.beforePlotAreaMouseEnter(_this, outerArgs);
                    }
                    _this._plotAreaMouseEnter.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._plotAreaMouseEnter;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaMouseLeave", {
        /**
         * Occurs when the pointer exits the plot area.
        */
        get: function () {
            var _this = this;
            if (this._plotAreaMouseLeave == null) {
                this._plotAreaMouseLeave = new EventEmitter();
                this.i.plotAreaMouseLeave = delegateCombine(this.i.plotAreaMouseLeave, function (o, e) {
                    var outerArgs = new IgxPlotAreaMouseEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforePlotAreaMouseLeave) {
                        _this.beforePlotAreaMouseLeave(_this, outerArgs);
                    }
                    _this._plotAreaMouseLeave.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._plotAreaMouseLeave;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaMouseOver", {
        /**
         * Occurs when the pointer if over the plot area.
        */
        get: function () {
            var _this = this;
            if (this._plotAreaMouseOver == null) {
                this._plotAreaMouseOver = new EventEmitter();
                this.i.plotAreaMouseOver = delegateCombine(this.i.plotAreaMouseOver, function (o, e) {
                    var outerArgs = new IgxPlotAreaMouseEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforePlotAreaMouseOver) {
                        _this.beforePlotAreaMouseOver(_this, outerArgs);
                    }
                    _this._plotAreaMouseOver.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._plotAreaMouseOver;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesCursorMouseMove", {
        /**
         * Occurs when the cursors are moved over a series in this SeriesViewer.
        */
        get: function () {
            var _this = this;
            if (this._seriesCursorMouseMove == null) {
                this._seriesCursorMouseMove = new EventEmitter();
                this.i.seriesCursorMouseMove = delegateCombine(this.i.seriesCursorMouseMove, function (o, e) {
                    var outerArgs = new IgxChartCursorEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeSeriesCursorMouseMove) {
                        _this.beforeSeriesCursorMouseMove(_this, outerArgs);
                    }
                    _this._seriesCursorMouseMove.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._seriesCursorMouseMove;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseLeftButtonDown", {
        /**
         * Occurs when the left mouse button is pressed while the mouse pointer is over a Series.
        *
        * The `SeriesMouseLeftButtonDown` event occurs when the left mouse button is pressed while the mouse pointer is over an element of this chart.
        *
        * &lt;-- position: content member-->
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     (seriesMouseLeftButtonDown)="onSeriesMouseLeftButtonDown($event)">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         thickness=5>
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * public onSeriesMouseLeftButtonDown(event: {sender: any, args: DataChartMouseButtonEventArgs})
        * {
        *     var item = event.args.item;
        * }
        * ```
        */
        get: function () {
            var _this = this;
            if (this._seriesMouseLeftButtonDown == null) {
                this._seriesMouseLeftButtonDown = new EventEmitter();
                this.i.seriesMouseLeftButtonDown = delegateCombine(this.i.seriesMouseLeftButtonDown, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxDataChartMouseButtonEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeSeriesMouseLeftButtonDown) {
                            _this.beforeSeriesMouseLeftButtonDown(_this, outerArgs);
                        }
                        _this._seriesMouseLeftButtonDown.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesMouseLeftButtonDown;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseLeftButtonUp", {
        /**
         * Occurs when the left mouse button is released while the mouse pointer is over a Series.
        *
        * The `SeriesMouseLeftButtonUp` event occurs when the left mouse button is released while the mouse pointer is over an element of this chart.
        *
        * &lt;-- position: content member-->
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     (seriesMouseLeftButtonUp)="onSeriesMouseLeftButtonUp($event)">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         thickness=5>
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * &lt;-- position: content member-->
        *
        * ```ts
        * public onSeriesMouseLeftButtonUp(event: {sender: any, args: DataChartMouseButtonEventArgs})
        * {
        *     var item = event.args.item;
        * }
        * ```
        *
        * ```ts
        * public onSeriesMouseLeftButtonUp =(event: any, args: DataChartMouseButtonEventArgs )
        * {
        *
        * }
        * ```
        */
        get: function () {
            var _this = this;
            if (this._seriesMouseLeftButtonUp == null) {
                this._seriesMouseLeftButtonUp = new EventEmitter();
                this.i.seriesMouseLeftButtonUp = delegateCombine(this.i.seriesMouseLeftButtonUp, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxDataChartMouseButtonEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeSeriesMouseLeftButtonUp) {
                            _this.beforeSeriesMouseLeftButtonUp(_this, outerArgs);
                        }
                        _this._seriesMouseLeftButtonUp.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesMouseLeftButtonUp;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseMove", {
        /**
         * Occurs when the mouse pointer moves while over a Series.
        *
        * The `SeriesMouseMove` event occurs when the left mouse pointer moves while over an element of this chart.
        *
        * &lt;-- position: content member-->
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     (seriesMouseMove)="onSeriesMouseMove($event)">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         thickness=5>
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * &lt;-- position: content member-->
        *
        * ```ts
        * public onSeriesMouseMove(event: {sender: any, args: ChartMouseEventArgs})
        * {
        *     var item = event.args.item;
        * }
        * ```
        *
        * ```ts
        * public onSeriesMouseMove =( event: any, args: ChartMouseEventArgs) => {
        *                  }
        * ```
        */
        get: function () {
            var _this = this;
            if (this._seriesMouseMove == null) {
                this._seriesMouseMove = new EventEmitter();
                this.i.seriesMouseMove = delegateCombine(this.i.seriesMouseMove, function (o, e) {
                    var outerArgs = new IgxChartMouseEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeSeriesMouseMove) {
                        _this.beforeSeriesMouseMove(_this, outerArgs);
                    }
                    _this._seriesMouseMove.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._seriesMouseMove;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseEnter", {
        /**
         * Occurs when the mouse pointer enters a Series.
        *
        * The `SeriesMouseEnter` event occurs when the left mouse pointer enters an element of this chart.
        *
        * &lt;-- position: content member-->
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     (seriesMouseEnter)="onSeriesMouseEnter($event)">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         thickness=5>
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * public onSeriesMouseEnter(event: {sender: any, args: ChartMouseEventArgs})
        * {
        *     var item = event.args.item;
        * }
        * ```
        */
        get: function () {
            var _this = this;
            if (this._seriesMouseEnter == null) {
                this._seriesMouseEnter = new EventEmitter();
                this.i.seriesMouseEnter = delegateCombine(this.i.seriesMouseEnter, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxChartMouseEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeSeriesMouseEnter) {
                            _this.beforeSeriesMouseEnter(_this, outerArgs);
                        }
                        _this._seriesMouseEnter.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesMouseEnter;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseLeave", {
        /**
         * Occurs when the mouse pointer leaves a Series.
        *
        * The `SeriesMouseLeave` event occurs when the left mouse pointer leaves an element of this chart.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     (seriesMouseLeave)="onSeriesMouseLeave($event)">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         thickness=5>
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * public onSeriesMouseLeave(event: {sender: any, args: ChartMouseEventArgs})
        * {
        *     var item = event.args.item;
        * }
        * ```
        */
        get: function () {
            var _this = this;
            if (this._seriesMouseLeave == null) {
                this._seriesMouseLeave = new EventEmitter();
                this.i.seriesMouseLeave = delegateCombine(this.i.seriesMouseLeave, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new IgxChartMouseEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeSeriesMouseLeave) {
                            _this.beforeSeriesMouseLeave(_this, outerArgs);
                        }
                        _this._seriesMouseLeave.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesMouseLeave;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "viewerManipulationStarting", {
        /**
         * Raised when an ongoing manipulation of the series viewer is started.
        */
        get: function () {
            var _this = this;
            if (this._viewerManipulationStarting == null) {
                this._viewerManipulationStarting = new EventEmitter();
                this.i.viewerManipulationStarting = delegateCombine(this.i.viewerManipulationStarting, function (o, e) {
                    var outerArgs = new IgxSeriesViewerManipulationEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeViewerManipulationStarting) {
                        _this.beforeViewerManipulationStarting(_this, outerArgs);
                    }
                    _this._viewerManipulationStarting.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._viewerManipulationStarting;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "viewerManipulationEnding", {
        /**
         * Raised when an ongoing manipulation of the series viewer is ended.
        */
        get: function () {
            var _this = this;
            if (this._viewerManipulationEnding == null) {
                this._viewerManipulationEnding = new EventEmitter();
                this.i.viewerManipulationEnding = delegateCombine(this.i.viewerManipulationEnding, function (o, e) {
                    var outerArgs = new IgxSeriesViewerManipulationEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeViewerManipulationEnding) {
                        _this.beforeViewerManipulationEnding(_this, outerArgs);
                    }
                    _this._viewerManipulationEnding.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._viewerManipulationEnding;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowRectChanged", {
        /**
         * Occurs just after the current SeriesViewer's window rectangle is changed.
        *
        * &lt;-- position: content member-->
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     isHorizontalZoomEnabled=true
        *     (windowRectChanged)="onWindowRectChanged($event)">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * &lt;-- position: content member-->
        *
        * ```ts
        * public onWindowRectChanged(event: {sender: any, args: RectChangedEventArgs})
        * {
        *     let newRect: IgxRect = event.args.newRect;
        * }
        * ```
        *
        * ```ts
        * public onWindowRectChanged =( s:any, e: RectChangedEventArgs) => {
        *
        *        }
        * ```
        */
        get: function () {
            var _this = this;
            if (this._windowRectChanged == null) {
                this._windowRectChanged = new EventEmitter();
                this.i.windowRectChanged = delegateCombine(this.i.windowRectChanged, function (o, e) {
                    var outerArgs = new IgxRectChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeWindowRectChanged) {
                        _this.beforeWindowRectChanged(_this, outerArgs);
                    }
                    _this._windowRectChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._windowRectChanged;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "sizeChanged", {
        /**
         * Occurs after the size of the series viewer changes.
        *
        * &lt;-- position: content member-->
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     (sizeChanged)="onSizeChanged($event)">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * &lt;-- position: content member-->
        *
        * ```ts
        * public onSizeChanged(event: {sender: any, args: RectChangedEventArgs})
        * {
        *     let newRect: IgxRect = event.args.newRect;
        * }
        * ```
        *
        * ```ts
        * public onSizeChanged =(event: any, args: RectChangedEventArgs}){
        *
        * }
        * ```
        */
        get: function () {
            var _this = this;
            if (this._sizeChanged == null) {
                this._sizeChanged = new EventEmitter();
                this.i.sizeChanged = delegateCombine(this.i.sizeChanged, function (o, e) {
                    var outerArgs = new IgxRectChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeSizeChanged) {
                        _this.beforeSizeChanged(_this, outerArgs);
                    }
                    _this._sizeChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._sizeChanged;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowRectChanged", {
        /**
         * Raised when the actual window rectangle of the SeriesViewer changes.
        */
        get: function () {
            var _this = this;
            if (this._actualWindowRectChanged == null) {
                this._actualWindowRectChanged = new EventEmitter();
                this.i.actualWindowRectChanged = delegateCombine(this.i.actualWindowRectChanged, function (o, e) {
                    var outerArgs = new IgxRectChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeActualWindowRectChanged) {
                        _this.beforeActualWindowRectChanged(_this, outerArgs);
                    }
                    _this._actualWindowRectChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._actualWindowRectChanged;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "gridAreaRectChanged", {
        /**
         * Occurs just after the current SeriesViewer's grid area rectangle is changed.
         * The grid area may change as the result of the SeriesViewer being resized, or
         * of an axis being added or changing size, possibly in another SeriesViewer.
        */
        get: function () {
            var _this = this;
            if (this._gridAreaRectChanged == null) {
                this._gridAreaRectChanged = new EventEmitter();
                this.i.gridAreaRectChanged = delegateCombine(this.i.gridAreaRectChanged, function (o, e) {
                    var outerArgs = new IgxRectChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeGridAreaRectChanged) {
                        _this.beforeGridAreaRectChanged(_this, outerArgs);
                    }
                    _this._gridAreaRectChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._gridAreaRectChanged;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "refreshCompleted", {
        /**
         * Raised when the SeriesViewer's processing for an update has completed.
        */
        get: function () {
            var _this = this;
            if (this._refreshCompleted == null) {
                this._refreshCompleted = new EventEmitter();
                this.i.refreshCompleted = delegateCombine(this.i.refreshCompleted, function (o, e) {
                    var outerArgs = new IgxRefreshCompletedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeRefreshCompleted) {
                        _this.beforeRefreshCompleted(_this, outerArgs);
                    }
                    _this._refreshCompleted.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._refreshCompleted;
        },
        enumerable: false,
        configurable: true
    });
    IgxSeriesViewerComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxSeriesViewerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxSeriesViewerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxSeriesViewerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxSeriesViewerComponent, selector: "ng-component", inputs: { brushes: "brushes", outlines: "outlines", markerBrushes: "markerBrushes", markerOutlines: "markerOutlines", markerAutomaticBehavior: "markerAutomaticBehavior", crosshairPoint: "crosshairPoint", animateSeriesWhenAxisRangeChanges: "animateSeriesWhenAxisRangeChanges", isWindowSyncedToVisibleRange: "isWindowSyncedToVisibleRange", shouldSimulateHoverMoveCrosshairPoint: "shouldSimulateHoverMoveCrosshairPoint", highlightingMode: "highlightingMode", horizontalViewScrollbarMode: "horizontalViewScrollbarMode", verticalViewScrollbarMode: "verticalViewScrollbarMode", horizontalViewScrollbarPosition: "horizontalViewScrollbarPosition", verticalViewScrollbarPosition: "verticalViewScrollbarPosition", horizontalViewScrollbarFill: "horizontalViewScrollbarFill", horizontalViewScrollbarOutline: "horizontalViewScrollbarOutline", horizontalViewScrollbarStrokeThickness: "horizontalViewScrollbarStrokeThickness", horizontalViewScrollbarMaxOpacity: "horizontalViewScrollbarMaxOpacity", horizontalViewScrollbarCornerRadius: "horizontalViewScrollbarCornerRadius", horizontalViewScrollbarHeight: "horizontalViewScrollbarHeight", horizontalViewScrollbarInset: "horizontalViewScrollbarInset", horizontalViewScrollbarTrackStartInset: "horizontalViewScrollbarTrackStartInset", horizontalViewScrollbarTrackEndInset: "horizontalViewScrollbarTrackEndInset", horizontalViewScrollbarShouldAddAutoTrackInsets: "horizontalViewScrollbarShouldAddAutoTrackInsets", verticalViewScrollbarFill: "verticalViewScrollbarFill", verticalViewScrollbarOutline: "verticalViewScrollbarOutline", verticalViewScrollbarStrokeThickness: "verticalViewScrollbarStrokeThickness", verticalViewScrollbarMaxOpacity: "verticalViewScrollbarMaxOpacity", verticalViewScrollbarCornerRadius: "verticalViewScrollbarCornerRadius", verticalViewScrollbarWidth: "verticalViewScrollbarWidth", verticalViewScrollbarInset: "verticalViewScrollbarInset", verticalViewScrollbarTrackStartInset: "verticalViewScrollbarTrackStartInset", verticalViewScrollbarTrackEndInset: "verticalViewScrollbarTrackEndInset", verticalViewScrollbarShouldAddAutoTrackInsets: "verticalViewScrollbarShouldAddAutoTrackInsets", highlightingBehavior: "highlightingBehavior", legendHighlightingMode: "legendHighlightingMode", legendItemBadgeShape: "legendItemBadgeShape", legendItemBadgeMode: "legendItemBadgeMode", effectiveViewport: "effectiveViewport", windowRect: "windowRect", useTiledZooming: "useTiledZooming", preferHigherResolutionTiles: "preferHigherResolutionTiles", zoomTileCacheSize: "zoomTileCacheSize", highlightingTransitionDuration: "highlightingTransitionDuration", scrollbarsAnimationDuration: "scrollbarsAnimationDuration", isPagePanningAllowed: "isPagePanningAllowed", contentHitTestMode: "contentHitTestMode", actualContentHitTestMode: "actualContentHitTestMode", isSurfaceInteractionDisabled: "isSurfaceInteractionDisabled", windowResponse: "windowResponse", windowRectMinWidth: "windowRectMinWidth", windowRectMinHeight: "windowRectMinHeight", actualWindowRectMinWidth: "actualWindowRectMinWidth", actualWindowRectMinHeight: "actualWindowRectMinHeight", windowSizeMinWidth: "windowSizeMinWidth", windowSizeMinHeight: "windowSizeMinHeight", crosshairVisibility: "crosshairVisibility", horizontalCrosshairBrush: "horizontalCrosshairBrush", verticalCrosshairBrush: "verticalCrosshairBrush", zoomCoercionMode: "zoomCoercionMode", plotAreaBackground: "plotAreaBackground", defaultInteraction: "defaultInteraction", rightButtonDefaultInteraction: "rightButtonDefaultInteraction", dragModifier: "dragModifier", panModifier: "panModifier", previewRect: "previewRect", windowPositionHorizontal: "windowPositionHorizontal", windowPositionVertical: "windowPositionVertical", chartTitle: "chartTitle", titleHorizontalAlignment: "titleHorizontalAlignment", subtitleHorizontalAlignment: "subtitleHorizontalAlignment", titleTextStyle: "titleTextStyle", subtitleTextStyle: "subtitleTextStyle", titleTextColor: "titleTextColor", subtitleTextColor: "subtitleTextColor", titleTopMargin: "titleTopMargin", titleLeftMargin: "titleLeftMargin", titleRightMargin: "titleRightMargin", titleBottomMargin: "titleBottomMargin", subtitleTopMargin: "subtitleTopMargin", subtitleLeftMargin: "subtitleLeftMargin", subtitleRightMargin: "subtitleRightMargin", subtitleBottomMargin: "subtitleBottomMargin", subtitle: "subtitle", topMargin: "topMargin", leftMargin: "leftMargin", rightMargin: "rightMargin", bottomMargin: "bottomMargin", autoMarginWidth: "autoMarginWidth", autoMarginHeight: "autoMarginHeight", isAntiAliasingEnabledDuringInteraction: "isAntiAliasingEnabledDuringInteraction", pixelScalingRatio: "pixelScalingRatio", interactionPixelScalingRatio: "interactionPixelScalingRatio", actualPixelScalingRatio: "actualPixelScalingRatio", actualInteractionPixelScalingRatio: "actualInteractionPixelScalingRatio", shouldPanOnMaximumZoom: "shouldPanOnMaximumZoom", actualWindowRect: "actualWindowRect", actualWindowPositionHorizontal: "actualWindowPositionHorizontal", actualWindowPositionVertical: "actualWindowPositionVertical" }, outputs: { plotAreaMouseLeftButtonDown: "plotAreaMouseLeftButtonDown", plotAreaMouseLeftButtonUp: "plotAreaMouseLeftButtonUp", plotAreaClicked: "plotAreaClicked", plotAreaMouseEnter: "plotAreaMouseEnter", plotAreaMouseLeave: "plotAreaMouseLeave", plotAreaMouseOver: "plotAreaMouseOver", seriesCursorMouseMove: "seriesCursorMouseMove", seriesMouseLeftButtonDown: "seriesMouseLeftButtonDown", seriesMouseLeftButtonUp: "seriesMouseLeftButtonUp", seriesMouseMove: "seriesMouseMove", seriesMouseEnter: "seriesMouseEnter", seriesMouseLeave: "seriesMouseLeave", viewerManipulationStarting: "viewerManipulationStarting", viewerManipulationEnding: "viewerManipulationEnding", windowRectChanged: "windowRectChanged", sizeChanged: "sizeChanged", actualWindowRectChanged: "actualWindowRectChanged", gridAreaRectChanged: "gridAreaRectChanged", refreshCompleted: "refreshCompleted" }, ngImport: i0, template: "", isInline: true });
    return IgxSeriesViewerComponent;
}());
export { IgxSeriesViewerComponent };
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxSeriesViewerComponent, decorators: [{
            type: Component,
            args: [{
                    template: "",
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { brushes: [{
                type: Input
            }], outlines: [{
                type: Input
            }], markerBrushes: [{
                type: Input
            }], markerOutlines: [{
                type: Input
            }], markerAutomaticBehavior: [{
                type: Input
            }], crosshairPoint: [{
                type: Input
            }], animateSeriesWhenAxisRangeChanges: [{
                type: Input
            }], isWindowSyncedToVisibleRange: [{
                type: Input
            }], shouldSimulateHoverMoveCrosshairPoint: [{
                type: Input
            }], highlightingMode: [{
                type: Input
            }], horizontalViewScrollbarMode: [{
                type: Input
            }], verticalViewScrollbarMode: [{
                type: Input
            }], horizontalViewScrollbarPosition: [{
                type: Input
            }], verticalViewScrollbarPosition: [{
                type: Input
            }], horizontalViewScrollbarFill: [{
                type: Input
            }], horizontalViewScrollbarOutline: [{
                type: Input
            }], horizontalViewScrollbarStrokeThickness: [{
                type: Input
            }], horizontalViewScrollbarMaxOpacity: [{
                type: Input
            }], horizontalViewScrollbarCornerRadius: [{
                type: Input
            }], horizontalViewScrollbarHeight: [{
                type: Input
            }], horizontalViewScrollbarInset: [{
                type: Input
            }], horizontalViewScrollbarTrackStartInset: [{
                type: Input
            }], horizontalViewScrollbarTrackEndInset: [{
                type: Input
            }], horizontalViewScrollbarShouldAddAutoTrackInsets: [{
                type: Input
            }], verticalViewScrollbarFill: [{
                type: Input
            }], verticalViewScrollbarOutline: [{
                type: Input
            }], verticalViewScrollbarStrokeThickness: [{
                type: Input
            }], verticalViewScrollbarMaxOpacity: [{
                type: Input
            }], verticalViewScrollbarCornerRadius: [{
                type: Input
            }], verticalViewScrollbarWidth: [{
                type: Input
            }], verticalViewScrollbarInset: [{
                type: Input
            }], verticalViewScrollbarTrackStartInset: [{
                type: Input
            }], verticalViewScrollbarTrackEndInset: [{
                type: Input
            }], verticalViewScrollbarShouldAddAutoTrackInsets: [{
                type: Input
            }], highlightingBehavior: [{
                type: Input
            }], legendHighlightingMode: [{
                type: Input
            }], legendItemBadgeShape: [{
                type: Input
            }], legendItemBadgeMode: [{
                type: Input
            }], effectiveViewport: [{
                type: Input
            }], windowRect: [{
                type: Input
            }], useTiledZooming: [{
                type: Input
            }], preferHigherResolutionTiles: [{
                type: Input
            }], zoomTileCacheSize: [{
                type: Input
            }], highlightingTransitionDuration: [{
                type: Input
            }], scrollbarsAnimationDuration: [{
                type: Input
            }], isPagePanningAllowed: [{
                type: Input
            }], contentHitTestMode: [{
                type: Input
            }], actualContentHitTestMode: [{
                type: Input
            }], isSurfaceInteractionDisabled: [{
                type: Input
            }], windowResponse: [{
                type: Input
            }], windowRectMinWidth: [{
                type: Input
            }], windowRectMinHeight: [{
                type: Input
            }], actualWindowRectMinWidth: [{
                type: Input
            }], actualWindowRectMinHeight: [{
                type: Input
            }], windowSizeMinWidth: [{
                type: Input
            }], windowSizeMinHeight: [{
                type: Input
            }], crosshairVisibility: [{
                type: Input
            }], horizontalCrosshairBrush: [{
                type: Input
            }], verticalCrosshairBrush: [{
                type: Input
            }], zoomCoercionMode: [{
                type: Input
            }], plotAreaBackground: [{
                type: Input
            }], defaultInteraction: [{
                type: Input
            }], rightButtonDefaultInteraction: [{
                type: Input
            }], dragModifier: [{
                type: Input
            }], panModifier: [{
                type: Input
            }], previewRect: [{
                type: Input
            }], windowPositionHorizontal: [{
                type: Input
            }], windowPositionVertical: [{
                type: Input
            }], chartTitle: [{
                type: Input
            }], titleHorizontalAlignment: [{
                type: Input
            }], subtitleHorizontalAlignment: [{
                type: Input
            }], titleTextStyle: [{
                type: Input
            }], subtitleTextStyle: [{
                type: Input
            }], titleTextColor: [{
                type: Input
            }], subtitleTextColor: [{
                type: Input
            }], titleTopMargin: [{
                type: Input
            }], titleLeftMargin: [{
                type: Input
            }], titleRightMargin: [{
                type: Input
            }], titleBottomMargin: [{
                type: Input
            }], subtitleTopMargin: [{
                type: Input
            }], subtitleLeftMargin: [{
                type: Input
            }], subtitleRightMargin: [{
                type: Input
            }], subtitleBottomMargin: [{
                type: Input
            }], subtitle: [{
                type: Input
            }], topMargin: [{
                type: Input
            }], leftMargin: [{
                type: Input
            }], rightMargin: [{
                type: Input
            }], bottomMargin: [{
                type: Input
            }], autoMarginWidth: [{
                type: Input
            }], autoMarginHeight: [{
                type: Input
            }], isAntiAliasingEnabledDuringInteraction: [{
                type: Input
            }], pixelScalingRatio: [{
                type: Input
            }], interactionPixelScalingRatio: [{
                type: Input
            }], actualPixelScalingRatio: [{
                type: Input
            }], actualInteractionPixelScalingRatio: [{
                type: Input
            }], shouldPanOnMaximumZoom: [{
                type: Input
            }], actualWindowRect: [{
                type: Input
            }], actualWindowPositionHorizontal: [{
                type: Input
            }], actualWindowPositionVertical: [{
                type: Input
            }], plotAreaMouseLeftButtonDown: [{
                type: Output
            }], plotAreaMouseLeftButtonUp: [{
                type: Output
            }], plotAreaClicked: [{
                type: Output
            }], plotAreaMouseEnter: [{
                type: Output
            }], plotAreaMouseLeave: [{
                type: Output
            }], plotAreaMouseOver: [{
                type: Output
            }], seriesCursorMouseMove: [{
                type: Output
            }], seriesMouseLeftButtonDown: [{
                type: Output
            }], seriesMouseLeftButtonUp: [{
                type: Output
            }], seriesMouseMove: [{
                type: Output
            }], seriesMouseEnter: [{
                type: Output
            }], seriesMouseLeave: [{
                type: Output
            }], viewerManipulationStarting: [{
                type: Output
            }], viewerManipulationEnding: [{
                type: Output
            }], windowRectChanged: [{
                type: Output
            }], sizeChanged: [{
                type: Output
            }], actualWindowRectChanged: [{
                type: Output
            }], gridAreaRectChanged: [{
                type: Output
            }], refreshCompleted: [{
                type: Output
            }] } });
