import { __extends } from "tslib";
import { Component } from '@angular/core';
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import * as i0 from "@angular/core";
/**
 * A base class for indicator series with simple calculations that separates the calculation
 * responsibility from the other responsibilities of the financial series, this enables
 * easier unit testing and decoupling of individual calculation strategies.
 * A contract is defined between the financial series and these simple indicator calculations
 * detailing the data which the series agrees to provide the simple indicator calculations,
 * this contract is defined by
 * FinancialCalculationDataSource. If more
 * complex interactions are needed between the indicator calculation and the series, the
 * indicators should instead derive from
 * FinancialIndicator directly, or some
 * derivative other than
 * StrategyBasedIndicator
*/
var IgxStrategyBasedIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxStrategyBasedIndicatorComponent, _super);
    function IgxStrategyBasedIndicatorComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxStrategyBasedIndicatorComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgxStrategyBasedIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxStrategyBasedIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxStrategyBasedIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: IgxStrategyBasedIndicatorComponent, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "", isInline: true });
    return IgxStrategyBasedIndicatorComponent;
}(IgxFinancialIndicatorComponent));
export { IgxStrategyBasedIndicatorComponent };
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0, type: IgxStrategyBasedIndicatorComponent, decorators: [{
            type: Component,
            args: [{
                    template: "",
                }]
        }], ctorParameters: function () { return []; } });
