import { Type } from "igniteui-angular-core";
/**
 * Describes available behaviors for how annotations are distinguished from series.
 */
export declare enum AnnotationAppearanceMode {
    /**
     * Let the annotation layer decide what appearance to use.
     */
    Auto = 0,
    /**
     * Take the target series color and shift the brightness.
     */
    BrightnessShift = 1,
    /**
     * Take the target series color and shift the saturation.
     */
    SaturationShift = 2,
    /**
     * Take the target series color and apply a dash pattern.
     */
    DashPattern = 3,
    /**
     * Take the target series color and shift the opacity.
     */
    OpacityShift = 4
}
/**
 * @hidden
 */
export declare let AnnotationAppearanceMode_$type: Type;
