import { Type } from "igniteui-angular-core";
/**
 * Describes available locations of the axis labels in the chart.
 */
export declare enum SeriesPlotAreaMarginHorizontalMode {
    /**
     * Series horizontal plot area margin mode is determined by the component.
     */
    Auto = 0,
    /**
     * The left of the horizontal axis will have a plot area margin, if applicable, and the right of the horizontal axis will have a plot area margin, if applicable.
     */
    LeftMarginRightMargin = 1,
    /**
     * The left of the horizontal axis will have a range buffer, if applicable, and the right of the horizontal axis will have a range buffer, if applicable.
     */
    LeftBufferRightBuffer = 2,
    /**
     * The left of the horizontal axis will have a plot area margin, if applicable, and the right of the horizontal axis will have a range buffer, if applicable.
     */
    LeftMarginRightBuffer = 3,
    /**
     * The left of the horizontal axis will have a range buffer, if applicable, and the right of the horizontal axis will have a plot area margin, if applicable.
     */
    LeftBufferRightMargin = 4,
    /**
     * No horizontal contributions to plot area margins will be made.
     */
    None = 5
}
/**
 * @hidden
 */
export declare let SeriesPlotAreaMarginHorizontalMode_$type: Type;
