import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { AccumulationDistributionIndicator } from "./AccumulationDistributionIndicator";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent Accumulation/Distribution indicator series.
 * Default required members: Close, Low, High, Volume
*
* You can use the `AccumulationDistributionIndicator` to evaluate the suppy and demand of a stock, security, or index.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-accumulation-distribution-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-accumulation-distribution-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxAccumulationDistributionIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
export declare class IgxAccumulationDistributionIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    protected createImplementation(): AccumulationDistributionIndicator;
    /**
                                 * @hidden
                                 */
    get i(): AccumulationDistributionIndicator;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxAccumulationDistributionIndicatorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxAccumulationDistributionIndicatorComponent, "igx-accumulation-distribution-indicator", never, {}, {}, never, never>;
}
