import { IgRect } from "igniteui-angular-core";
import { IgPoint } from "igniteui-angular-core";
import { IgxNumericXAxisComponent } from "./igx-numeric-x-axis-component";
import { IgxCategoryYAxisComponent } from "./igx-category-y-axis-component";
import { IgxColumnFragmentComponent } from "./igx-column-fragment-component";
import { BarFragment } from "./BarFragment";
import * as i0 from "@angular/core";
/**
 * Represents one part of a StackedBarSeries.
*/
export declare class IgxBarFragmentComponent extends IgxColumnFragmentComponent {
    protected createImplementation(): BarFragment;
    /**
                                 * @hidden
                                 */
    get i(): BarFragment;
    constructor();
    /**
     * Gets whether the current series shows a bar shape.
    */
    get isBar(): boolean;
    static ngAcceptInputType_isBar: boolean | string;
    /**
     * Overridden by derived series classes to indicate when marker-less display is preferred or not.
    */
    get isMarkerlessDisplayPreferred(): boolean;
    static ngAcceptInputType_isMarkerlessDisplayPreferred: boolean | string;
    /**
     * Gets whether the current series shows a column shape.
    */
    get isColumn(): boolean;
    static ngAcceptInputType_isColumn: boolean | string;
    /**
     * The X-Axis for this BarFragment.
    */
    get barFragmentXAxis(): IgxNumericXAxisComponent;
    /**
     * The Y-Axis for this BarFragment.
    */
    get barFragmentYAxis(): IgxCategoryYAxisComponent;
    get isVertical(): boolean;
    static ngAcceptInputType_isVertical: boolean | string;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    */
    getExactItemIndex(world: IgPoint): number;
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    getSeriesValueBoundingBox(world: IgPoint): IgRect;
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world: IgPoint): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxBarFragmentComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxBarFragmentComponent, "igx-bar-fragment", never, {}, {}, never, never>;
}
