import { IgxChartSortDescription } from "./igx-chart-sort-description";
import { ChartSortDescriptionCollection as ChartSortDescriptionCollection_internal } from "./ChartSortDescriptionCollection";
/**
 * Represents a collection of sort elements that are applied to a data source or provider.
*/
export declare class IgxChartSortDescriptionCollection {
    protected createImplementation(): ChartSortDescriptionCollection_internal;
    protected _implementation: any;
    get i(): ChartSortDescriptionCollection_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    item(index: number, value?: IgxChartSortDescription): IgxChartSortDescription;
    get count(): number;
    toArray(): IgxChartSortDescription[];
    [Symbol.iterator](): Generator<any, void, unknown>;
    /**
 * Gets or sets whether this collection should detach the sync when the target collection changes.
*/
    get shouldDetachOnTargetChange(): boolean;
    set shouldDetachOnTargetChange(v: boolean);
    static ngAcceptInputType_shouldDetachOnTargetChange: boolean | string;
    findByName(name: string): any;
    add(item: IgxChartSortDescription): boolean;
    insert(index: number, item: IgxChartSortDescription): void;
    clear(): void;
    indexOf(item: IgxChartSortDescription): number;
    remove(item: IgxChartSortDescription): boolean;
    removeAt(index: number): IgxChartSortDescription;
}
