import { ListSortDirection } from "igniteui-angular-core";
import { ChartSortDescription } from "./ChartSortDescription";
/**
 * Represents an element in the current sort applied to a data source or provider. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
export declare class IgxChartSortDescription {
    protected createImplementation(): ChartSortDescription;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): ChartSortDescription;
    private onImplementationCreated;
    constructor(field?: string, sortDirection?: ListSortDirection);
    protected _provideImplementation(i: any): void;
    /**
 * Gets or sets the property being sorted.
*/
    get field(): string;
    set field(v: string);
    /**
     * Gets or sets the direction to sort based on the property.
    */
    get sortDirection(): ListSortDirection;
    set sortDirection(v: ListSortDirection);
    static ngAcceptInputType_sortDirection: ListSortDirection | string;
    findByName(name: string): any;
    /**
 * Returns if the SortDescription is equal to another.

* @param other  * The SortDescription to compare to.
*/
    equals(other: any): boolean;
}
