import { EventEmitter } from '@angular/core';
import { DataSourceSummaryOperand } from "igniteui-angular-core";
import { IgxProvideCalculatorEventArgs } from "igniteui-angular-core";
import { ChartSummaryDescription as ChartSummaryDescription_internal } from "./ChartSummaryDescription";
/**
 * Represents a summary that is applied to a datasource. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
export declare class IgxChartSummaryDescription {
    protected createImplementation(): ChartSummaryDescription_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): ChartSummaryDescription_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    get field(): string;
    set field(v: string);
    get operand(): DataSourceSummaryOperand;
    set operand(v: DataSourceSummaryOperand);
    static ngAcceptInputType_operand: DataSourceSummaryOperand | string;
    /**
     * Gets or sets an alias for the summary. Currently only used in aggregated data situations.
    */
    get alias(): string;
    set alias(v: string);
    /**
     * Gets or sets the name to use when displaying the calculator name.
    */
    get calculatorDisplayName(): string;
    set calculatorDisplayName(v: string);
    findByName(name: string): any;
    equals(other: any): boolean;
    private _provideCalculator;
    /**
     * Called when the summary calculator is required.
    */
    get provideCalculator(): EventEmitter<{
        sender: any;
        args: IgxProvideCalculatorEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
