import { BrushSelectionMode } from "./BrushSelectionMode";
import { IgxBrushScaleComponent } from "./igx-brush-scale-component";
import { CustomPaletteBrushScale } from "./CustomPaletteBrushScale";
import * as i0 from "@angular/core";
/**
 * Represents a brush scale that uses index-based brush selection mode.
*/
export declare class IgxCustomPaletteBrushScaleComponent extends IgxBrushScaleComponent {
    protected createImplementation(): CustomPaletteBrushScale;
    /**
                                 * @hidden
                                 */
    get i(): CustomPaletteBrushScale;
    constructor();
    /**
     * Gets or sets the brush selection mode.
    */
    get brushSelectionMode(): BrushSelectionMode;
    set brushSelectionMode(v: BrushSelectionMode);
    static ngAcceptInputType_brushSelectionMode: BrushSelectionMode | string;
    /**
     * Checks if this scale is ready for useage with a series
    */
    get isReady(): boolean;
    static ngAcceptInputType_isReady: boolean | string;
    getBrush1(index: number, total: number): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxCustomPaletteBrushScaleComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxCustomPaletteBrushScaleComponent, "igx-custom-palette-brush-scale", never, { "brushSelectionMode": "brushSelectionMode"; }, {}, never, never>;
}
