import { IgxSeriesComponent } from "./igx-series-component";
import { IgxAnnotationLayerComponent } from "./igx-annotation-layer-component";
import { ItemToolTipLayer } from "./ItemToolTipLayer";
import * as i0 from "@angular/core";
/**
 * Represents an annotation layer that displays tooltips for all target series individually.
*/
export declare class IgxItemToolTipLayerComponent extends IgxAnnotationLayerComponent {
    protected createImplementation(): ItemToolTipLayer;
    /**
                                 * @hidden
                                 */
    get i(): ItemToolTipLayer;
    constructor();
    /**
     * Gets whether the series is an annotation layer displayed only when hovering over the chart.
    */
    get isAnnotationHoverLayer(): boolean;
    static ngAcceptInputType_isAnnotationHoverLayer: boolean | string;
    /**
     * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
    */
    get isDefaultTooltipBehaviorDisabled(): boolean;
    static ngAcceptInputType_isDefaultTooltipBehaviorDisabled: boolean | string;
    /**
     * Gets or sets the name of the series series to target this annotation to. If null, this annotation targets all series simultaneously.
    */
    get targetSeriesName(): string;
    set targetSeriesName(v: string);
    /**
     * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
    */
    get targetSeries(): IgxSeriesComponent;
    set targetSeries(v: IgxSeriesComponent);
    /**
     * Gets or sets whether to use value interpolation when drawing the tooltips.
    */
    get useInterpolation(): boolean;
    set useInterpolation(v: boolean);
    static ngAcceptInputType_useInterpolation: boolean | string;
    /**
     * Gets or sets whether to skip past unknown values when searching for series values.
    */
    get skipUnknownValues(): boolean;
    set skipUnknownValues(v: boolean);
    static ngAcceptInputType_skipUnknownValues: boolean | string;
    findByName(name: string): any;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    hideToolTips(): void;
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    hideToolTipsImmediate(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxItemToolTipLayerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxItemToolTipLayerComponent, "igx-item-tool-tip-layer", never, { "targetSeriesName": "targetSeriesName"; "targetSeries": "targetSeries"; "useInterpolation": "useInterpolation"; "skipUnknownValues": "skipUnknownValues"; }, {}, never, never>;
}
