import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { ItemwiseStrategyBasedIndicator } from "./ItemwiseStrategyBasedIndicator";
import * as i0 from "@angular/core";
/**
 * Financial indicator base class for doing calculating an itemwize indicator.
 * An itemwise indicator's individual values don't depend on any other values in the
 * collection so can always be independently recalculated. Also, because of this, the
 * base class handles all the looping logic and inheritors only need to provide the
 * actual calculation.
*/
export declare abstract class IgxItemwiseStrategyBasedIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    /**
                                 * @hidden
                                 */
    get i(): ItemwiseStrategyBasedIndicator;
    constructor();
    /**
     * This is a marker method to distinguish this from a public api perspective on some platforms compared to the base strategy based indicators.
    
    */
    resolveIsItemwise(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxItemwiseStrategyBasedIndicatorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxItemwiseStrategyBasedIndicatorComponent, "ng-component", never, {}, {}, never, never>;
}
