import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { OnBalanceVolumeIndicator } from "./OnBalanceVolumeIndicator";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent On Balance Bolume indicator series.
 * Default required members: Close, Volume
*
* You can use the `OnBalanceVolumeIndicator` to calculate a running total of sales volume for a stock.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-on-balance-volume-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-on-balance-volume-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxOnBalanceVolumeIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
export declare class IgxOnBalanceVolumeIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    protected createImplementation(): OnBalanceVolumeIndicator;
    /**
                                 * @hidden
                                 */
    get i(): OnBalanceVolumeIndicator;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxOnBalanceVolumeIndicatorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxOnBalanceVolumeIndicatorComponent, "igx-on-balance-volume-indicator", never, {}, {}, never, never>;
}
