import { IgxRing } from "./igx-ring";
import { IgxRingSeriesBaseComponent } from "./igx-ring-series-base-component";
import { RingSeries } from "./RingSeries";
import { IgxIndexCollection } from "./igx-index-collection";
import * as i0 from "@angular/core";
/**
 * Represents one ring in
 * IgxDoughnutChartComponent series.
*/
export declare class IgxRingSeriesComponent extends IgxRingSeriesBaseComponent {
    protected createImplementation(): RingSeries;
    get i(): RingSeries;
    constructor();
    private _explodedSlices;
    /**
     * Gets or sets the collection of exploded slice indices.
    */
    get explodedSlices(): IgxIndexCollection;
    set explodedSlices(v: IgxIndexCollection);
    private _selectedSlices;
    /**
     * Gets or sets the collection of selected slice indices.
    */
    get selectedSlices(): IgxIndexCollection;
    set selectedSlices(v: IgxIndexCollection);
    sychronizeCollections(): void;
    /**
 * Gets reference to the ring data.
*/
    get ring(): IgxRing;
    set ring(v: IgxRing);
    findByName(name: string): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxRingSeriesComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxRingSeriesComponent, "igx-ring-series", never, { "explodedSlices": "explodedSlices"; "selectedSlices": "selectedSlices"; "ring": "ring"; }, {}, never, never>;
}
