import { IgxValueBrushScaleComponent } from "./igx-value-brush-scale-component";
import { IgxContourValueResolverComponent } from "./igx-contour-value-resolver-component";
import { IgxScatterTriangulationSeriesComponent } from "./igx-scatter-triangulation-series-component";
import { ScatterContourSeries } from "./ScatterContourSeries";
import * as i0 from "@angular/core";
/**
 * Series class for rendering isarithmic contours based on a triangulation of X+Y+Value points in the ItemsSource.
*/
export declare class IgxScatterContourSeriesComponent extends IgxScatterTriangulationSeriesComponent {
    protected createImplementation(): ScatterContourSeries;
    /**
                                 * @hidden
                                 */
    get i(): ScatterContourSeries;
    constructor();
    /**
     * Gets whether the current series shows a line contour shape.
    */
    get isLineContour(): boolean;
    static ngAcceptInputType_isLineContour: boolean | string;
    /**
     * Gets or set the name of the property from which to retrieve the numeric values from the ItemsSource items.
    */
    get valueMemberPath(): string;
    set valueMemberPath(v: string);
    /**
     * Gets or sets the label displayed before series value in the Data Legend.
    */
    get valueMemberAsLegendLabel(): string;
    set valueMemberAsLegendLabel(v: string);
    /**
     * Gets or sets the unit displayed after series value in the Data Legend.
    */
    get valueMemberAsLegendUnit(): string;
    set valueMemberAsLegendUnit(v: string);
    /**
     * Gets or sets the ValueBrushScale to use when determining Brushes for each contour line, based on the values found in ValueMemberPath.
    */
    get fillScale(): IgxValueBrushScaleComponent;
    set fillScale(v: IgxValueBrushScaleComponent);
    /**
     * Gets actual fill scale that is set on the FillScale property or default FillScale
    */
    get actualFillScale(): IgxValueBrushScaleComponent;
    set actualFillScale(v: IgxValueBrushScaleComponent);
    /**
     * Gets or set the ContourValueResolver used to determine the numeric values of contours.
    */
    get valueResolver(): IgxContourValueResolverComponent;
    set valueResolver(v: IgxContourValueResolverComponent);
    findByName(name: string): any;
    protected _styling(container: any, component: any, parent?: any): void;
    getItemValue(item: any, memberPathName: string): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxScatterContourSeriesComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxScatterContourSeriesComponent, "igx-scatter-contour-series", never, { "valueMemberPath": "valueMemberPath"; "valueMemberAsLegendLabel": "valueMemberAsLegendLabel"; "valueMemberAsLegendUnit": "valueMemberAsLegendUnit"; "fillScale": "fillScale"; "actualFillScale": "actualFillScale"; "valueResolver": "valueResolver"; }, {}, never, never>;
}
