import { SplineType } from "./SplineType";
import { IgxHorizontalAnchoredCategorySeriesComponent } from "./igx-horizontal-anchored-category-series-component";
import { SplineSeriesBase } from "./SplineSeriesBase";
import * as i0 from "@angular/core";
/**
 * Represents the base class for all IgxDataChartComponent spline series.
*/
export declare abstract class IgxSplineSeriesBaseComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    /**
                                 * @hidden
                                 */
    get i(): SplineSeriesBase;
    constructor();
    /**
     * Gets or sets whether to include the spline shape in the axis range requested of the axis.
    */
    get isSplineShapePartOfRange(): boolean;
    set isSplineShapePartOfRange(v: boolean);
    static ngAcceptInputType_isSplineShapePartOfRange: boolean | string;
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine(): boolean;
    static ngAcceptInputType_isAreaOrLine: boolean | string;
    /**
     * Gets or sets the type of spline to be rendered.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-spline-area-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         splineType="clamped"
    *         valueMemberPath="value">
    *     </igx-spline-area-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.splineType = SplineType.Clamped;
    * ```
    */
    get splineType(): SplineType;
    set splineType(v: SplineType);
    static ngAcceptInputType_splineType: SplineType | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxSplineSeriesBaseComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxSplineSeriesBaseComponent, "ng-component", never, { "isSplineShapePartOfRange": "isSplineShapePartOfRange"; "splineType": "splineType"; }, {}, never, never>;
}
