import { IgxHorizontalAnchoredCategorySeriesComponent } from "./igx-horizontal-anchored-category-series-component";
import { StepAreaSeries } from "./StepAreaSeries";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent step area series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-step-area-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-step-area-series>
* </igx-data-chart>
* ```
*
* ```ts
*    let series = new IgxStepAreaSeriesComponent();
*    series.xAxis = this.xAxis;
*    series.yAxis = this.yAxis;
*    series.valueMemberPath="value";
*    this.chart.series.add(series);
* ```
*/
export declare class IgxStepAreaSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    protected createImplementation(): StepAreaSeries;
    /**
                                 * @hidden
                                 */
    get i(): StepAreaSeries;
    constructor();
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine(): boolean;
    static ngAcceptInputType_isAreaOrLine: boolean | string;
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea(): boolean;
    static ngAcceptInputType_isArea: boolean | string;
    /**
     * Gets whether the current series shows step shapes.
    */
    get isStep(): boolean;
    static ngAcceptInputType_isStep: boolean | string;
    /**
     * Overridden by derived series classes to indicate when marker-less display is preferred or not.
    */
    get isMarkerlessDisplayPreferred(): boolean;
    static ngAcceptInputType_isMarkerlessDisplayPreferred: boolean | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxStepAreaSeriesComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxStepAreaSeriesComponent, "igx-step-area-series", never, {}, {}, never, never>;
}
