import { OnInit } from "@angular/core";
import { TimeAxisInterval } from "./TimeAxisInterval";
import { TimeAxisIntervalType } from "./TimeAxisIntervalType";
import * as i0 from "@angular/core";
export declare class IgxTimeAxisIntervalComponent implements OnInit {
    protected _implementation: any;
    get i(): TimeAxisInterval;
    private onImplementationCreated;
    constructor();
    protected createImplementation(): TimeAxisInterval;
    ngOnInit(): void;
    private _renderer;
    private _provideRenderer;
    static _createFromInternal(internal: any): IgxTimeAxisIntervalComponent;
    /**
 * The visible axis range at which to apply this interval.
*
* Use `Range` property for the visible axis range at which to apply this interval.
*
* ```ts
* let xAxis = new IgxTimeXAxisComponent();
* xAxis.dataTimeMemberPath="date";
* this.chart.axes.add(xAxis);
* ```
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-time-x-axis
* 		[labelFormats]="labelFormats"
* 		dateTimeMemberPath="time"
*
* 		#xAxis>
*     </igx-time-x-axis>
* </igx-data-chart>
* ```
*/
    get range(): number;
    set range(v: number);
    static ngAcceptInputType_range: number | string;
    /**
     * The interval, expressed as a multiple of IntervalType.
    *
    * Use the `Interval` property expressed as a multiple of IntervalType.
    *
    * ```ts
    * let xAxis = new IgxTimeXAxisComponent();
    * xAxis.dataTimeMemberPath="date";
    * this.chart.axes.add(xAxis);
    * ```
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-time-x-axis
    * 		[labelFormats]="labelFormats"
    * 		dateTimeMemberPath="time"
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    */
    get interval(): number;
    set interval(v: number);
    static ngAcceptInputType_interval: number | string;
    /**
     * The unit of time for this interval.
    *
    * The `IntervalType` is the unit of time for this interval.
    */
    get intervalType(): TimeAxisIntervalType;
    set intervalType(v: TimeAxisIntervalType);
    static ngAcceptInputType_intervalType: TimeAxisIntervalType | string;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxTimeAxisIntervalComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxTimeAxisIntervalComponent, "igx-time-axis-interval", never, { "range": "range"; "interval": "interval"; "intervalType": "intervalType"; }, {}, never, never>;
}
