import { TreemapNodeStyleMappingTargetType } from "./TreemapNodeStyleMappingTargetType";
import { TreemapValueMappingMode } from "./TreemapValueMappingMode";
import { IgxTreemapNodeStyleComponent } from "./igx-treemap-node-style-component";
import { TreemapNodeStyleMapping } from "./TreemapNodeStyleMapping";
import * as i0 from "@angular/core";
/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
export declare class IgxTreemapNodeStyleMappingComponent extends IgxTreemapNodeStyleComponent {
    protected createImplementation(): TreemapNodeStyleMapping;
    /**
                                 * @hidden
                                 */
    get i(): TreemapNodeStyleMapping;
    constructor();
    /**
     * Gets or sets the unique name of the mapping.
    */
    get targetType(): TreemapNodeStyleMappingTargetType;
    set targetType(v: TreemapNodeStyleMappingTargetType);
    static ngAcceptInputType_targetType: TreemapNodeStyleMappingTargetType | string;
    /**
     * Gets or sets the unique name of the mapping.
    */
    get name(): string;
    set name(v: string);
    /**
     * Gets or sets the minimum value to which the mapping applies.
    */
    get minimumValue(): number;
    set minimumValue(v: number);
    static ngAcceptInputType_minimumValue: number | string;
    /**
     * Gets or sets the maximum value to which the mapping applies.
    */
    get maximumValue(): number;
    set maximumValue(v: number);
    static ngAcceptInputType_maximumValue: number | string;
    /**
     * Gets or sets the value to which the mapping applies.
    */
    get value(): any;
    set value(v: any);
    /**
     * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
    */
    get mappingMode(): TreemapValueMappingMode;
    set mappingMode(v: TreemapValueMappingMode);
    static ngAcceptInputType_mappingMode: TreemapValueMappingMode | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxTreemapNodeStyleMappingComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxTreemapNodeStyleMappingComponent, "igx-treemap-node-style-mapping", never, { "targetType": "targetType"; "name": "name"; "minimumValue": "minimumValue"; "maximumValue": "maximumValue"; "value": "value"; "mappingMode": "mappingMode"; }, {}, never, never>;
}
