import { IgxNumericXAxisComponent } from "./igx-numeric-x-axis-component";
import { IgxCategoryYAxisComponent } from "./igx-category-y-axis-component";
import { IgxStackedSeriesBaseComponent } from "./igx-stacked-series-base-component";
import { VerticalStackedSeriesBase } from "./VerticalStackedSeriesBase";
import * as i0 from "@angular/core";
/**
 * Base class for stacked series with a numeric x-axis and a category y-axis.
*/
export declare abstract class IgxVerticalStackedSeriesBaseComponent extends IgxStackedSeriesBaseComponent {
    /**
                                 * @hidden
                                 */
    get i(): VerticalStackedSeriesBase;
    constructor();
    /**
     * Gets or sets the effective x-axis for the current CategorySeries object.
    */
    get xAxis(): IgxNumericXAxisComponent;
    set xAxis(v: IgxNumericXAxisComponent);
    /**
     * Gets or sets the effective y-axis for the current CategorySeries object.
    */
    get yAxis(): IgxCategoryYAxisComponent;
    set yAxis(v: IgxCategoryYAxisComponent);
    /**
     * Gets whether or not the current series is vertical series
    */
    get isVertical(): boolean;
    static ngAcceptInputType_isVertical: boolean | string;
    findByName(name: string): any;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    getOffsetValue(): number;
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    getCategoryWidth(): number;
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    canUseAsYAxis(axis: any): boolean;
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    canUseAsXAxis(axis: any): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxVerticalStackedSeriesBaseComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxVerticalStackedSeriesBaseComponent, "ng-component", never, { "xAxis": "xAxis"; "yAxis": "yAxis"; }, {}, never, never>;
}
